//-----------------------------------------
// ATBakeIKtoFK -- LScript Genetic
// Noboru Fujiyama 2003/07/21
//  Bake IK->FK 
//
//  use IKtoRotClient.ls 
@version 2.5
@script generic
@name ATBakeIKtoFK

@define AUTOMATON_VER 2.5


@define LAST_DIR "LastDir_Pose"

@define TYPE_AM  1 /* Automaton */
@define TYPE_MB  2 /* MotionBuilderCharacterize */
s_xParentItem ;
s_nTypeFlag = TYPE_AM ;

/* Automaton */
s_asUpperArray = @"L_Shoulder2_IKNull","R_Shoulder2_IKNull",
			"R_Shoulder","R_NFS_IK1","R_NFS_IK2","R_Shoulder2","R_ArmDir","R_Arm","R_Elbow","R_ForeArm","R_ForearmDir","R_HandDir","R_Hand","R_Hand_Tip","R_ForearmDir_IKNull",
			"L_Shoulder","L_NFS_IK1","L_NFS_IK2","L_Shoulder2","L_ArmDir","L_Arm","L_Elbow","L_ForeArm","L_ForearmDir","L_HandDir","L_Hand","L_Hand_Tip","L_ForearmDir_IKNull",
			"RootSpin","Spine1","Spine2","Spine3","NeckNull","Neck","Head",
			"L_ArmGoal","R_ArmGoal","HeadGoal",
			 "R_Shoulder_a","R_ShoulderCtr","L_Shoulder_a","L_ShoulderCtr" ,
			 "Neck_a"   ,"Neck_b"    ,"Neck_c" ,"Neck_d"  ,"Neck_e"      ,"Neck_f"       ,"Neck_g",
			 "Spine_a"  ,"Spine_b"   ,"Spine_c", "L_ArmTipGoal","R_ArmTipGoal","L_ArmRot","R_ArmRot"@;
			

s_asLowerArray = @"L_Hip2_IKNull","R_Hip2_IKNull","L_FtTipGoal","R_FtTipGoal","L_FtRot","R_FtRot",
			 "R_Hip","R_Hip2","R_LegDir","R_Thigh","R_Knee","R_Shin","R_FootDir","R_Foot","R_FootTip",
			 "L_Hip","L_Hip2","L_LegDir","L_Thigh","L_Knee","L_Shin","L_FootDir","L_Foot","L_FootTip",
			 "R_HipNull","R_HipNFS_IK1","R_HipNFS_IK2",
			 "L_HipNull","L_HipNFS_IK1","L_HipNFS_IK2",
			 "Root","R_FtCtrl","L_FtCtrl","HeadGoal",
			 "R_Hip_a"  ,"R_HipCtr"  ,"L_Hip_a","L_HipCtr",
			 "Tail_a"   ,"Tail_b"    ,"Tail_c" ,"Tail_d"  ,"Tail_e"      ,"Tail_f"       ,"Tail_g","Tail_Null","Tail_Start"@;


s_asGlobalTRName = @"Root","L_ArmGoal","R_ArmGoal","R_FtCtrl","L_FtCtrl","HeadGoal","Tail_IKCtrl"@;

/*MotionBuilderCharacterize*/

s_asUpperArrayMB = 
			@"LeftShoulder2_IKNull","RightShoulder2_IKNull",
			 "RightShoulder","RightNFS_IK1","RightNFS_IK2","RightShoulder2","RightArmDir","RightArm","RightForeArm","RightForearmDir","RightHandDir","RightHand","RightHand_Tip","RightForearmDir_IKNull",
			 "LeftShoulder","LeftNFS_IK1","LeftNFS_IK2","LeftShoulder2","LeftArmDir","LeftArm","LeftForeArm","LeftForearmDir","LeftHandDir","LeftHand","LeftHand_Tip","LeftForearmDir_IKNull",
			 "HipsSpin","Spine","Spine1","Spine2","Spine3","NeckNull","Neck","Head",
			 "L_ArmGoal","R_ArmGoal","HeadGoal",
			 "Neck1"   ,"Neck2"    ,"Neck3" ,"Neck4"  ,"Neck5"      ,"Neck6"       ,"Neck7",
			 "Spine4"  ,"Spine5"   ,"Spine6", "L_ArmTipGoal","R_ArmTipGoal","L_ArmRot","R_ArmRot"@;
			

s_asLowerArrayMB = @"LeftHip2_IKNull","RightHip2_IKNull","L_FtTipGoal","R_FtTipGoal","L_FtRot","R_FtRot",
			 "RightHip","RightHip2","RightLegDir","RightUpLeg","RightLeg","RightFootDir","RightFoot","RightToeBase",
			 "LeftHip","LeftHip2","LeftLegDir","LeftUpLeg","LeftLeg","LeftFootDir","LeftFoot","LeftToeBase",
			 "RightHipNull","RightHipNFS_IK1","RightHipNFS_IK2",
			 "LeftHipNull" ,"LeftHipNFS_IK1" ,"LeftHipNFS_IK2",
			 "Hips","R_FtCtrl","L_FtCtrl","HeadGoal",
			 "Tail1"   ,"Tail2"    ,"Tail3" ,"Tail4"  ,"Tail5"      ,"Tail6"       ,"Tail7","Tail_Null","Tail_Start"@;

s_asGlobalTRNameMB = @"Hips","L_ArmGoal","R_ArmGoal","R_FtCtrl","L_FtCtrl","HeadGoal","Tail_IKCtrl"@;


s_asRotName ;
s_asControlRotName ;
s_nValueChk = 1 ;
s_IKMode = false ;
s_ItemNum;
s_asItemNames;
s_avRots;

/* puah/pop seleced item */
s_nSelectedNum ;
s_axSelectedItem ;
s_xParentItem ;

/* searchItem */
s_xSearchItem = nil ;


generic 
{
	curScene = Scene();

	/* puah seleced item */
	xSelected = curScene.firstSelect();
	if( xSelected == nil)
	{
		error("<br>You must select something before performing this operation." );
		return;		
	}	
	push_selected_item( curScene , xSelected );
	curItem = s_xParentItem ;
	if( 0 == ( s_nTypeFlag = check_item( s_xParentItem , 6 ) ) )
	{
		error("<br>You must select Automaton character Item ." );
		return;		
	}	
	/**/
	var1 = curScene.framestart ;
	var2 = curScene.frameend;
	nOffset = 1;
	var4 = 1;
	
	reqbegin("ATBakeIKtoFK " + AUTOMATON_VER );
    reqsize(488,158);

    c1 = ctlslider("Start",var1,var1,var2);
    ctlposition(c1,5,8);


    c2 = ctlslider("  End",var2,var1,var2);
    ctlposition(c2,5,34);


    c3 = ctlminislider("Offset",nOffset,1,100);
    ctlposition(c3,5,58);

    c4 = ctlchoice(" Bake",var4,@"Body","Lower","Upper"@);
    ctlposition(c4,5,90,230,21);

    return if !reqpost();

    var1 = getvalue(c1);
    var2 = getvalue(c2);
    nOffset = getvalue(c3);
    var4 = getvalue(c4);


	reqend();
	nItem = 0  ;
	/* Open Temporary File */
	if( var4 == 1 || var4 == 2 )
	{
		if( s_nTypeFlag == TYPE_AM )
		{
			for( nItem1 = nItem+1 ; nItem1 <= s_asLowerArray.size() ; nItem1++ )
			{
				s_asRotName[ nItem1 ] = s_asLowerArray[ nItem1 ]; 
			}
			nItem = nItem1 ;
		}
		else {
			for( nItem1 = nItem+1 ; nItem1 <= s_asLowerArrayMB.size() ; nItem1++ )
			{
				s_asRotName[ nItem1 ] = s_asLowerArrayMB[ nItem1 ]; 
			}
			nItem = nItem1 ;
		}
	}
	if( var4 == 1 || var4 == 3 )
	{
		if( s_nTypeFlag == TYPE_AM )
		{
			for( nItem2 = 1  ; nItem2 <= s_asUpperArray.size() ; nItem2++ )
			{
				s_asRotName[ nItem2+nItem ] = s_asUpperArray[ nItem2 ]; 
			}
		}
		else {
			for( nItem2 = 1 ; nItem2 <= s_asUpperArrayMB.size() ; nItem2++ )
			{
				s_asRotName[  nItem2+nItem ] = s_asUpperArrayMB[ nItem2 ]; 
			}
		}
	}

	/* Open Temporary File */
	sFilePath = getdir("Content") + "\\temp\\localrot";
	/* collect motion data */
	fileName = sFilePath + "\\_tempPose.lrt" ;
	if((textFile = File( fileName , "w" ) ) == nil)
	{
		error("No Temporary Directry ", sFilePath  );
		return;		
	} 
	textFile.close() ;
	
	/* apply IKtoRotClient plugin */
	apply_server( s_xParentItem ) ;
	/* KtoRotClient plugin motion data Output */
	RefreshNow();

	// collect motion data
	files = matchfiles( sFilePath , "*.txt" );
	var outputTextBuf ;
	for( i = 1 ; i <= files.count() ; i++ )
	{
		outputTextBuf[ i ] = "" ;
	}
	for( nFrame = var1 ; nFrame <= var2 ; nFrame+=nOffset )
	{
		GoToFrame( nFrame );
		CommandInput( "RefreshNow" );
		nOutputLocalRot = 0;
		for( i = 1 ; i <= files.count() ; i++ )
		{
			if( "Root" != files[ i ] )
			{
				// Open Item Rotation Data 
				sNullFileName = sFilePath + "\\" + files[ i ] ; 
				nullFile = File( sNullFileName , "r") ;
				if(nullFile.linecount())
				{
					sLine = nullFile.read() ;
					outputTextBuf[ i ] = sLine ;
					nOutputLocalRot++ ;
				}
				nullFile.close();
			}
		}

		if((textFile = File( fileName , "w" ) ) == nil)
		{
			error("Dos not open file ", fileName );
			/* remove IKtoRotClient plugin */
			remove_server( s_xParentItem );
			return;		
		} 
		for( i = 1 ; i <= files.count() ; i++ )
		{
			textFile.writeln( outputTextBuf[ i ] );
		} 
		textFile.close() ;
		if(  0 == nOutputLocalRot )
		{
			info( "Not Setup IKToLocalRotClient!!" );
		}
		else {
			// create key 
			loadLocalRot( fileName , curItem , curScene , nFrame / curScene.fps ) ;
		}
	}

	/* remove IKtoRotClient plugin */
	remove_server(s_xParentItem );
	/* pop seleced item  */
	pop_selected_item( ) ;
}

check_item: xTop,nNum
{
	for( i = 1 ; i <= nNum ; i++ )
	{
		s_xSearchItem = nil ;
		searchItem( xTop , s_asGlobalTRName[ i ] );
		if( s_xSearchItem == nil )
		{
			for( i = 1 ; i <= nNum ; i++ )
			{
				s_xSearchItem = nil ;
				searchItem( xTop , s_asGlobalTRNameMB[ i ] );
				if( s_xSearchItem == nil )
				{
					return 0;
				}
			}
			return TYPE_MB ;
		}		
	}
	return TYPE_AM  ;
}

/* push/pop seleced item  */
push_selected_item:scene , xSelected 
{
	/* get selected item */
	for( s_nSelectedNum = 1 ; xSelected ; ++s_nSelectedNum )
	{
		s_axSelectedItem[ s_nSelectedNum ] = xSelected ;
		xSelected = scene.nextSelect();
	}
	/* seek Top Item  */
	s_xParentItem = s_axSelectedItem[ 1 ] ;
	while( nil != s_xParentItem.parent )
	{
		s_xParentItem = s_xParentItem.parent ;
	}
}

/* push/pop seleced item  */
pop_selected_item
{
	// select item 
	SelectItem( s_axSelectedItem[ 1 ].id );
	for( nLoop = 2 ; nLoop < s_nSelectedNum ; nLoop++ )
	{
		AddToSelection( s_axSelectedItem[ nLoop ].id );
	}
}


outputLocalRot : rootObj,name,time,file
{
	xName = parse( " (" , rootObj.name ) ;
	if( xName[ 1 ] == name )
	{
		vVec = rootObj.getRotation(time) ;
 		file.write( name , ":" );
		file.write( " <" , vVec , ">\n" );
		
		return ;
	}
	childObj = rootObj.firstChild();
	while(childObj)
	{
		outputLocalRot(childObj,name,time,file);
		childObj = rootObj.nextChild();
	}
}


outputLocalTR : rootObj,name,time,file
{
	xName = parse( " (" , rootObj.name ) ;
	if( xName[ 1 ] == name )
	{
		//vVecRot = get_global_rotation(rootObj,time) ;
		vVecRot = rootObj.getRotation(time) ;
		vVecPos = rootObj.getPosition(time) ;
 		file.write( name , ":LT:" );
		file.write( " <" , vVecPos , ">" );
 		file.write( ":LR:" );
		file.write( " <" , vVecRot , ">\n" );
		
		return ;
	}
	childObj = rootObj.firstChild();
	while(childObj)
	{
		outputLocalTR(childObj,name,time,file);
		childObj = rootObj.nextChild();
	}
}


/******************    Acs3b Save Bone Rotation Data  ******************/

apply_server: xTop 
{
	for( i = 1 ; i <= s_asRotName.size() ; i++ )
	{
		apply_item( xTop , s_asRotName[ i ] );
	}
}

remove_server: xTop 
{
	for( i = 1 ; i <=  s_asRotName.size() ; i++ )
	{
		remove_item( xTop , s_asRotName[ i ] );
	}
}
apply_item : top  , sName 
{
	s_xSearchItem = nil ;
	searchItem( top , sName );
	if( s_xSearchItem != nil )
	{
		SelectItem( s_xSearchItem.id );
		CommandInput( "ApplyServer ItemMotionHandler IKtoRotClient");
	}

}
remove_item : top  , sName 
{
	s_xSearchItem = nil ;
	searchItem( top , sName );
	if( s_xSearchItem != nil )
	{
		SelectItem( s_xSearchItem.id );
		CommandInput( "RemoveServer ItemMotionHandler IKtoRotClient");
	}

}

searchItem: xItem , sName 
{
	xMesh = xItem.firstChild();
	while( xMesh )
	{
		xName = parse( " (" , xMesh.name ) ;
		if( sName == xName[ 1 ] )
		{
			s_xSearchItem  = xMesh ;		
			return ;
		}
		else {
			searchItem( xMesh , sName  );
			if( nil != s_xSearchItem )
			{
				return ;		
			}
		}
		xMesh = xItem.nextChild();
	}
}
/********************************************************/
/*   get_global_rotation                                */
/********************************************************/
get_global_rotation: xItem , time 
{
	var mMtx[4][4] ;
	var vRot = <0,0,0> ;
	
	//vRot = xItem.getWorldRotation(time) ;
	matrix_identity( mMtx );
	get_global_matrix( xItem , time , mMtx );
	vTemp = LWMAT_getYXZrotations( mMtx , vRot  );

	vVecRot = <((vTemp[1]*180)/3.1415926),((vTemp[2]*180)/3.1415926),((vTemp[3]*180)/3.1415926)>;
	return vVecRot ;
}
/********************************************************/
/*   get_global_matrix                            */
/********************************************************/
get_global_matrix: xItem , time ,mMtx 
{
	matrix_identity( mMtx );
	while( xItem != nil )
	{
		var mTemp[4][4];
		var mOrg[4][4];
		matrix_copy( mOrg  , mMtx );
		get_item_matrix( xItem , time , mTemp );
		matrix_mul_matrix( mMtx , mOrg , mTemp    );
		xItem = xItem.parent ;
	}
	
}

get_item_matrix : xItem , time , mtx 
{
	vTrans = xItem.getPosition( time );
	vRot   = xItem.getRotation( time );
	vScale   = xItem.getScaling( time );
	//vPivot   = xItem.getPivot( time );
	var mTemp[4][4];
	var mScale[ 4 ][ 4 ] ;
	var mTrans[ 4 ][ 4 ] ;
	var mRot[ 4 ][ 4 ] ;
	
	matrix_copy( mTemp , mtx );
	matrix_scale( mScale , vScale );
	matrix_trans( mTrans , vTrans );
	matrix_rotation( mRot , ( vRot.y / 180 ) * 3.1415927 ,  ( vRot.x / 180 ) * 3.1415927 , ( vRot.z / 180 ) * 3.1415927 );
	// scale -> Rot -> Trans -> Pivot 
	matrix_mul_matrix( mTemp   , mScale , mRot  );
	matrix_mul_matrix( mtx , mTemp , mTrans );
}


loadLocalRot: fileName , curItem,curScene , time 
{
	if((textFile = File(fileName)) == nil)
	{
		error("Could not open file ", fileName );
		return;		
	} 

	line = nil;
	s_ItemNum=1 ;
	while( textFile.eof() != true)
	{
		line = textFile.read();
		if( nil != line )
		{
			items = parse(":",line);
			if( 1 < items.count() )
			{
				if( 3 > items.count() )
				{
					s_asItemNames[s_ItemNum] = items[1] ; 
					s_avRots[s_ItemNum] = vector( items[2] ) ;
					s_ItemNum++ ;
				}
				else {
					s_asItemNames[s_ItemNum] = items[1] ; 
					s_avRots[s_ItemNum] = vector( items[5] ) ;
					s_ItemNum++ ;
				}
			}
		}
	}
	nameToId(curItem,time);
	textFile.close();
	RefreshNow();
}

nameToId : rootObj,time
{
	for( no = 1 ; no < s_ItemNum ; no++ )
	{
		if( rootObj.name == s_asItemNames[no] )
		{
			createKeys( rootObj , nil ,s_avRots[no] , nil ,time );
		}
	}
	childObj = rootObj.firstChild();
	while(childObj)
	{
		nameToId(childObj,time);
		childObj = rootObj.nextChild();
	}
}

createKeys: newItem , vTrans , vRot , vScale ,time
{
	curChannel = newItem.firstChannel();

	while( nil != curChannel )
	{
		if( vTrans != nil )
		{
			if(curChannel.name == "Position.X")
			{
				crateKey( curChannel , time ,vTrans.x);
			}
			if(curChannel.name == "Position.Y")
			{
				crateKey( curChannel , time ,vTrans.y);
			}
			if(curChannel.name == "Position.Z")
			{
				crateKey( curChannel , time ,vTrans.z);
			}
		}
		if( vRot != nil )
		{
			if(curChannel.name == "Rotation.H")
			{
				crateKey( curChannel , time ,vRot.x);
			}
			if(curChannel.name == "Rotation.P")
			{
				crateKey( curChannel , time ,vRot.y);
			}
			if(curChannel.name == "Rotation.B")
			{
				crateKey( curChannel , time ,vRot.z);
			}
		}
		if( vScale != nil )
		{
			if(curChannel.name == "Scale.X")
			{
				crateKey( curChannel , time ,vScale.x);
			}
			if(curChannel.name == "Scale.Y")
			{
				crateKey( curChannel , time ,vScale.y);
			}
			if(curChannel.name == "Scale.Z")
			{
				crateKey( curChannel , time ,vScale.z);
			}			
		}
		curChannel = newItem.nextChannel();
	}
}

crateKey: xChanel , time , value  
{
	if( 1 == s_nValueChk )
	{
		temp = xChanel.value( time );
		if( value != temp ) 
		{
			xChanel.createKey( time ,value );
		}
	}
	else {
		xChanel.createKey( time ,value );
	}
}

/**********************************************/
/*     Matrix                                 */
/**********************************************/
matrix_identity: mtx 
{
	mtx[1][1] = 1; mtx[1][2] = 0;  mtx[1][3] = 0;mtx[1][4] = 0;
	mtx[2][1] = 0; mtx[2][2] = 1;  mtx[2][3] = 0;mtx[2][4] = 0;
	mtx[3][1] = 0; mtx[3][2] = 0;  mtx[3][3] = 1;mtx[3][4] = 0;
	mtx[4][1] = 0; mtx[4][2] = 0;  mtx[4][3] = 0;mtx[4][4] = 1;
}

matrix_trans : mtx , vVec 
{
	mtx[1][1] = 1      ; mtx[1][2] = 0     ;  mtx[1][3] = 0     ;mtx[1][4] = 0;
	mtx[2][1] = 0      ; mtx[2][2] = 1     ;  mtx[2][3] = 0     ;mtx[2][4] = 0;
	mtx[3][1] = 0      ; mtx[3][2] = 0     ;  mtx[3][3] = 1     ;mtx[3][4] = 0;
	mtx[4][1] = vVec.x ; mtx[4][2] = vVec.y;  mtx[4][3] = vVec.z;mtx[4][4] = 1;
}

matrix_scale: mtx , vVec 
{
	mtx[1][1] = vVec.x ; mtx[1][2] = 0     ;  mtx[1][3] = 0     ;mtx[1][4] = 0;
	mtx[2][1] = 0      ; mtx[2][2] = vVec.y;  mtx[2][3] = 0     ;mtx[2][4] = 0;
	mtx[3][1] = 0      ; mtx[3][2] = 0     ;  mtx[3][3] = vVec.z;mtx[3][4] = 0;
	mtx[4][1] = 0      ; mtx[4][2] = 0     ;  mtx[4][3] = 0     ;mtx[4][4] = 1;
}

matrix_rotate_x: mtx ,dx 
{
	dsin = sin( dx );
	dcos = cos( dx );
	mtx[1][1] = 1.0 ; mtx[1][2] = 0;     mtx[1][3] = 0;    mtx[1][4] = 0;
	mtx[2][1] = 0;    mtx[2][2] = dcos;  mtx[2][3] = dsin; mtx[2][4] = 0;
	mtx[3][1] = 0;    mtx[3][2] = -dsin; mtx[3][3] = dcos; mtx[3][4] = 0;
	mtx[4][1] = 0;    mtx[4][2] =  0;    mtx[4][3] = 0;    mtx[4][4] = 1;
}                                                          

matrix_rotate_y:  mtx , dx 
{
	dsin = sin( dx );
	dcos = cos( dx );
	mtx[1][1] = dcos; mtx[1][2] = 0;  mtx[1][3] = -dsin;   mtx[1][4] = 0;
	mtx[2][1] = 0;    mtx[2][2] = 1;  mtx[2][3] = 0;       mtx[2][4] = 0;
	mtx[3][1] = dsin; mtx[3][2] = 0;  mtx[3][3] = dcos;    mtx[3][4] = 0;
	mtx[4][1] = 0;    mtx[4][2] =  0;    mtx[4][3] = 0;    mtx[4][4] = 1;
}

matrix_rotate_z:  mtx , dx 
{
	dsin = sin( dx );
	dcos = cos( dx );
	mtx[1][1] = dcos;  mtx[1][2] = dsin;  mtx[1][3] = 0;   mtx[1][4] = 0;
	mtx[2][1] = -dsin; mtx[2][2] = dcos;  mtx[2][3] = 0;   mtx[2][4] = 0;
	mtx[3][1] = 0 ;    mtx[3][2] = 0;     mtx[3][3] = 1;   mtx[3][4] = 0;
	mtx[4][1] = 0;     mtx[4][2] = 0;    mtx[4][3] = 0;    mtx[4][4] = 1;
}

matrix_rotation: mtx , x , y , z  
{
	var mX[4][4];
	var mY[4][4];
	var mZ[4][4];
	var mT[4][4];
	
	matrix_rotate_x( mX , x );
	matrix_rotate_y( mY , y );
	matrix_rotate_z( mZ , z );
	
	matrix_mul_matrix( mT , mX  , mY );
	matrix_mul_matrix( mtx , mZ  , mT );
}

matrix_mul_vector : inM , vVec
{
	vOutVec = < 0 , 0 , 0 >;
	vOutVec.x = inM[1][1] * vVec.x + inM[2][1] * vVec.y + inM[3][1] * vVec.z + inM[4][1] ;
	vOutVec.y = inM[1][2] * vVec.x + inM[2][2] * vVec.y + inM[3][2] * vVec.z + inM[4][2] ;
	vOutVec.z = inM[1][3] * vVec.x + inM[2][3] * vVec.y + inM[3][3] * vVec.z + inM[4][3] ;

	return vOutVec ;                                                         
}                                                                            
                                                                             
matrix_mul_matrix : ansM , inM1 , inM2 
{
	ansM[1][1] = inM1[1][1] * inM2[1][1] + inM1[1][2] * inM2[2][1] + inM1[1][3] * inM2[3][1] + inM1[1][4] * inM2[4][1]; 
	ansM[1][2] = inM1[1][1] * inM2[1][2] + inM1[1][2] * inM2[2][2] + inM1[1][3] * inM2[3][2] + inM1[1][4] * inM2[4][2]; 
	ansM[1][3] = inM1[1][1] * inM2[1][3] + inM1[1][2] * inM2[2][3] + inM1[1][3] * inM2[3][3] + inM1[1][4] * inM2[4][3]; 
	ansM[1][4] = inM1[1][1] * inM2[1][4] + inM1[1][2] * inM2[2][4] + inM1[1][3] * inM2[3][4] + inM1[1][4] * inM2[4][4]; 
	ansM[2][1] = inM1[2][1] * inM2[1][1] + inM1[2][2] * inM2[2][1] + inM1[2][3] * inM2[3][1] + inM1[2][4] * inM2[4][1];  
	ansM[2][2] = inM1[2][1] * inM2[1][2] + inM1[2][2] * inM2[2][2] + inM1[2][3] * inM2[3][2] + inM1[2][4] * inM2[4][2];   
	ansM[2][3] = inM1[2][1] * inM2[1][3] + inM1[2][2] * inM2[2][3] + inM1[2][3] * inM2[3][3] + inM1[2][4] * inM2[4][3]; 
	ansM[2][4] = inM1[2][1] * inM2[1][4] + inM1[2][2] * inM2[2][4] + inM1[2][3] * inM2[3][4] + inM1[2][4] * inM2[4][4]; 
	ansM[3][1] = inM1[3][1] * inM2[1][1] + inM1[3][2] * inM2[2][1] + inM1[3][3] * inM2[3][1] + inM1[3][4] * inM2[4][1];  
	ansM[3][2] = inM1[3][1] * inM2[1][2] + inM1[3][2] * inM2[2][2] + inM1[3][3] * inM2[3][2] + inM1[3][4] * inM2[4][2]; 
	ansM[3][3] = inM1[3][1] * inM2[1][3] + inM1[3][2] * inM2[2][3] + inM1[3][3] * inM2[3][3] + inM1[3][4] * inM2[4][3]; 
	ansM[3][4] = inM1[3][1] * inM2[1][4] + inM1[3][2] * inM2[2][4] + inM1[3][3] * inM2[3][4] + inM1[3][4] * inM2[4][4]; 
	ansM[4][1] = inM1[4][1] * inM2[1][1] + inM1[4][2] * inM2[2][1] + inM1[4][3] * inM2[3][1] + inM1[4][4] * inM2[4][1];  
	ansM[4][2] = inM1[4][1] * inM2[1][2] + inM1[4][2] * inM2[2][2] + inM1[4][3] * inM2[3][2] + inM1[4][4] * inM2[4][2]; 
	ansM[4][3] = inM1[4][1] * inM2[1][3] + inM1[4][2] * inM2[2][3] + inM1[4][3] * inM2[3][3] + inM1[4][4] * inM2[4][3]; 
	ansM[4][4] = inM1[4][1] * inM2[1][4] + inM1[4][2] * inM2[2][4] + inM1[4][3] * inM2[3][4] + inM1[4][4] * inM2[4][4]; 

}                                                                                           


matrix_mul_value: ansM , inValue 
{
	ansM[1][1] *= inValue ; ansM[1][2] *= inValue ;  ansM[1][3] *= inValue  ; ansM[1][4] *= inValue  ;
	ansM[2][1] *= inValue ; ansM[2][2] *= inValue ;  ansM[2][3] *= inValue  ; ansM[2][4] *= inValue  ;
	ansM[3][1] *= inValue ; ansM[3][2] *= inValue ;  ansM[3][3] *= inValue  ; ansM[3][4] *= inValue  ;
	ansM[4][1] *= inValue ; ansM[4][2] *= inValue ;  ansM[4][3] *= inValue  ; ansM[4][4] *= inValue  ;
}                                                                             
                                                                              
matrix_multipry : ansM , inM                                                  
{
	ansM[1][1] *= inM[1][1] ; ansM[1][2] *= inM[1][2] ;  ansM[1][3] *= inM[1][3] ; ansM[1][4] *= inM[1][4] ;
	ansM[2][1] *= inM[2][1] ; ansM[2][2] *= inM[2][2] ;  ansM[2][3] *= inM[2][3] ; ansM[2][4] *= inM[2][4] ;
	ansM[3][1] *= inM[3][1] ; ansM[3][2] *= inM[3][2] ;  ansM[3][3] *= inM[3][3] ; ansM[3][4] *= inM[3][4] ;
	ansM[4][1] *= inM[4][1] ; ansM[4][2] *= inM[4][2] ;  ansM[4][3] *= inM[4][3]  ;ansM[4][4] *= inM[4][4] ;
}	                                                                               
                                                                                   
matrix_add: ansM , inM 
{
	ansM[1][1] += inM[1][1] ; ansM[1][2] += inM[1][2] ;  ansM[1][3] += inM[1][3] ; ansM[1][4] += inM[1][4] ;
	ansM[2][1] += inM[2][1] ; ansM[2][2] += inM[2][2] ;  ansM[2][3] += inM[2][3] ; ansM[2][4] += inM[2][4] ;
	ansM[3][1] += inM[3][1] ; ansM[3][2] += inM[3][2] ;  ansM[3][3] += inM[3][3] ; ansM[3][4] += inM[3][4] ;
	ansM[4][1] += inM[4][1] ; ansM[4][2] += inM[4][2] ;  ansM[4][3] += inM[4][3] ; ansM[4][4] += inM[4][4] ;
}	                                                                              

matrix_copy: srcM , dstM 
{
	srcM[1][1] = dstM[1][1] ; srcM[1][2] = dstM[1][2] ;  srcM[1][3] = dstM[1][3] ; srcM[1][4] = dstM[1][4] ;
	srcM[2][1] = dstM[2][1] ; srcM[2][2] = dstM[2][2] ;  srcM[2][3] = dstM[2][3] ; srcM[2][4] = dstM[2][4] ;
	srcM[3][1] = dstM[3][1] ; srcM[3][2] = dstM[3][2] ;  srcM[3][3] = dstM[3][3] ; srcM[3][4] = dstM[3][4] ;
	srcM[4][1] = dstM[4][1] ; srcM[4][2] = dstM[4][2] ;  srcM[4][3] = dstM[4][3] ; srcM[4][4] = dstM[4][4] ;
	                                                                               
}                                                                                  
                                                                                   

matrix_determinant: mtx 
{
	return (  ( mtx[ 1 ][ 1 ]  * mtx[ 2 ][ 2 ] - mtx[ 1 ][ 2 ]  * mtx[ 2 ][ 1 ] ) * ( mtx[ 3 ][ 3 ]  * mtx[ 4 ][ 4 ] - mtx[ 3 ][ 4 ]  * mtx[ 4 ][ 3 ] )
			- ( mtx[ 1 ][ 1 ]  * mtx[ 2 ][ 3 ] - mtx[ 1 ][ 3 ]  * mtx[ 2 ][ 1 ] ) * ( mtx[ 3 ][ 2 ]  * mtx[ 4 ][ 4 ] - mtx[ 3 ][ 4 ]  * mtx[ 4 ][ 2 ] )
			+ ( mtx[ 1 ][ 1 ]  * mtx[ 2 ][ 4 ] - mtx[ 1 ][ 4 ]  * mtx[ 2 ][ 1 ] ) * ( mtx[ 3 ][ 2 ]  * mtx[ 4 ][ 3 ] - mtx[ 3 ][ 3 ]  * mtx[ 4 ][ 2 ] )
			+ ( mtx[ 1 ][ 2 ]  * mtx[ 2 ][ 3 ] - mtx[ 1 ][ 3 ]  * mtx[ 2 ][ 2 ] ) * ( mtx[ 3 ][ 1 ]  * mtx[ 4 ][ 4 ] - mtx[ 3 ][ 4 ]  * mtx[ 4 ][ 1 ] )
			- ( mtx[ 1 ][ 2 ]  * mtx[ 2 ][ 4 ] - mtx[ 1 ][ 4 ]  * mtx[ 2 ][ 2 ] ) * ( mtx[ 3 ][ 1 ]  * mtx[ 4 ][ 3 ] - mtx[ 3 ][ 3 ]  * mtx[ 4 ][ 1 ] )
			+ ( mtx[ 1 ][ 3 ]  * mtx[ 2 ][ 4 ] - mtx[ 1 ][ 4 ]  * mtx[ 2 ][ 3 ] ) * ( mtx[ 3 ][ 1 ]  * mtx[ 4 ][ 2 ] - mtx[ 3 ][ 2 ]  * mtx[ 4 ][ 1 ] )
			);                                     
}                                                  

matrix_mul_value : mtx, fVal 
{
	mtx[1][1] *= fVal; mtx[1][2] *= fVal;  mtx[1][3] *= fVal; mtx[1][4] *= fVal;
	mtx[2][1] *= fVal; mtx[2][2] *= fVal;  mtx[2][3] *= fVal; mtx[2][4] *= fVal;
	mtx[3][1] *= fVal; mtx[3][2] *= fVal;  mtx[3][3] *= fVal; mtx[3][4] *= fVal;
	mtx[4][1] *= fVal; mtx[4][2] *= fVal;  mtx[4][3] *= fVal; mtx[4][4] *= fVal;
}

matrix_invert: ansMtx , mtx 
{
	fDet = matrix_determinant( mtx );
	if ( dDet == 0.0 ) return;
	fDet = 1 / fDet ;


	ansMtx[1][1] = mtx[2][2]*(mtx[3][3]*mtx[4][4] - mtx[3][4]*mtx[4][3]) + mtx[2][3]*(mtx[3][4]*mtx[4][2] - mtx[3][2]*mtx[4][4]) + mtx[2][4]*(mtx[3][2]*mtx[4][3] - mtx[3][3]*mtx[4][2]);
	ansMtx[1][2] = mtx[3][2]*(mtx[1][3]*mtx[4][4] - mtx[1][4]*mtx[4][3]) + mtx[3][3]*(mtx[1][4]*mtx[4][2] - mtx[1][2]*mtx[4][4]) + mtx[3][4]*(mtx[1][2]*mtx[4][3] - mtx[1][3]*mtx[4][2]);
	ansMtx[1][3] = mtx[4][2]*(mtx[1][3]*mtx[2][4] - mtx[1][4]*mtx[2][3]) + mtx[4][3]*(mtx[1][4]*mtx[2][2] - mtx[1][2]*mtx[2][4]) + mtx[4][4]*(mtx[1][2]*mtx[2][3] - mtx[1][3]*mtx[2][2]);
	ansMtx[1][4] = mtx[1][2]*(mtx[2][4]*mtx[3][3] - mtx[2][3]*mtx[3][4]) + mtx[1][3]*(mtx[2][2]*mtx[3][4] - mtx[2][4]*mtx[3][2]) + mtx[1][4]*(mtx[2][3]*mtx[3][2] - mtx[2][2]*mtx[3][3]);

	ansMtx[2][1] = mtx[2][3]*(mtx[3][1]*mtx[4][4] - mtx[3][4]*mtx[4][1]) + mtx[2][4]*(mtx[3][3]*mtx[4][1] - mtx[3][1]*mtx[4][3]) + mtx[2][1]*(mtx[3][4]*mtx[4][3] - mtx[3][3]*mtx[4][4]);
	ansMtx[2][2] = mtx[3][3]*(mtx[1][1]*mtx[4][4] - mtx[1][4]*mtx[4][1]) + mtx[3][4]*(mtx[1][3]*mtx[4][1] - mtx[1][1]*mtx[4][3]) + mtx[3][1]*(mtx[1][4]*mtx[4][3] - mtx[1][3]*mtx[4][4]);
	ansMtx[2][3] = mtx[4][3]*(mtx[1][1]*mtx[2][4] - mtx[1][4]*mtx[2][1]) + mtx[4][4]*(mtx[1][3]*mtx[2][1] - mtx[1][1]*mtx[2][3]) + mtx[4][1]*(mtx[1][4]*mtx[2][3] - mtx[1][3]*mtx[2][4]);
	ansMtx[2][4] = mtx[1][3]*(mtx[2][4]*mtx[3][1] - mtx[2][1]*mtx[3][4]) + mtx[1][4]*(mtx[2][1]*mtx[3][3] - mtx[2][3]*mtx[3][1]) + mtx[1][1]*(mtx[2][3]*mtx[3][4] - mtx[2][4]*mtx[3][3]);

	ansMtx[3][1] = mtx[2][4]*(mtx[3][1]*mtx[4][2] - mtx[3][2]*mtx[4][1]) + mtx[2][1]*(mtx[3][2]*mtx[4][4] - mtx[3][4]*mtx[4][2]) + mtx[2][2]*(mtx[3][4]*mtx[4][1] - mtx[3][1]*mtx[4][4]);
	ansMtx[3][2] = mtx[3][4]*(mtx[1][1]*mtx[4][2] - mtx[1][2]*mtx[4][1]) + mtx[3][1]*(mtx[1][2]*mtx[4][4] - mtx[1][4]*mtx[4][2]) + mtx[3][2]*(mtx[1][4]*mtx[4][1] - mtx[1][1]*mtx[4][4]);
	ansMtx[3][3] = mtx[4][4]*(mtx[1][1]*mtx[2][2] - mtx[1][2]*mtx[2][1]) + mtx[4][1]*(mtx[1][2]*mtx[2][4] - mtx[1][4]*mtx[2][2]) + mtx[4][2]*(mtx[1][4]*mtx[2][1] - mtx[1][1]*mtx[2][4]);
	ansMtx[3][4] = mtx[1][4]*(mtx[2][2]*mtx[3][1] - mtx[2][1]*mtx[3][2]) + mtx[1][1]*(mtx[2][4]*mtx[3][2] - mtx[2][2]*mtx[3][4]) + mtx[1][2]*(mtx[2][1]*mtx[3][4] - mtx[2][4]*mtx[3][1]);

	ansMtx[4][1] = mtx[2][1]*(mtx[3][3]*mtx[4][2] - mtx[3][2]*mtx[4][3]) + mtx[2][2]*(mtx[3][1]*mtx[4][3] - mtx[3][3]*mtx[4][1]) + mtx[2][3]*(mtx[3][2]*mtx[4][1] - mtx[3][1]*mtx[4][2]);
	ansMtx[4][2] = mtx[3][1]*(mtx[1][3]*mtx[4][2] - mtx[1][2]*mtx[4][3]) + mtx[3][2]*(mtx[1][1]*mtx[4][3] - mtx[1][3]*mtx[4][1]) + mtx[3][3]*(mtx[1][2]*mtx[4][1] - mtx[1][1]*mtx[4][2]);
	ansMtx[4][3] = mtx[4][1]*(mtx[1][3]*mtx[2][2] - mtx[1][2]*mtx[2][3]) + mtx[4][2]*(mtx[1][1]*mtx[2][3] - mtx[1][3]*mtx[2][1]) + mtx[4][3]*(mtx[1][2]*mtx[2][1] - mtx[1][1]*mtx[2][2]);
	ansMtx[4][4] = mtx[1][1]*(mtx[2][2]*mtx[3][3] - mtx[2][3]*mtx[3][2]) + mtx[1][2]*(mtx[2][3]*mtx[3][1] - mtx[2][1]*mtx[3][3]) + mtx[1][3]*(mtx[2][1]*mtx[3][2] - mtx[2][2]*mtx[3][1]);
	                                                     
                                                 
	matrix_mul_value( ansMtx , fDet );
}

sgn: val
{
	if( val > 0.0 )
	{
		return 1 ;
	}
	else {
		return -1 ;
	} 
}

atan2:  y , x
{
	if( -0.000001 < x && x < 0.000001 )
	{
		if( -0.000001 < y && y <  0.000001 )
		{
			val = 0 ;
		}
		else {
			val = sgn(y) *  3.1415927 / 2 ;
		}
	}
	else if( x < 0 ) 
	{
		if( -0.000001 < y && y <  0.000001 )
		{
			val =  3.1415927  ;
		}
		else {
			val =  sgn(y) * 3.1415927 +  atan( y / x ) ;
		}
	}
	else {
		val =  atan( y / x ) ;
	}
	return val ;
}

LWMAT_getYXZrotations:  mtx , vec
{
	// Pitch
	var cp;
	var s;
	var c;
	var vTemp = <0,0,0>;

	// X
	if( mtx[3][2] > 1.0 )
	{
		vec[2] =asin(-1.0);
	}
	else if(mtx[3][2] < -1.0)
	{
		vec[2] = asin(1.0);
	}
	else
	{
		vec[2] = asin(-1.0 * mtx[3][2]);
	}
	cp = cos(vec[2]);

    if( !( -0.000001 < cp && cp < 0.000001 ) )
    {
		// Y
		s = mtx[3][1] / cp;
		c = mtx[3][3] / cp;
		vec[1] = atan2( s , c) ;

		// Z
		s = mtx[1][2] / cp;
		c = mtx[2][2] / cp;
		vec[3] = atan2( s , c);

 		if( abs(vec[ 3 ]) > ( 3.14159265 - 0.2 ) && abs(vec[ 1 ])  > ( 3.14159265 - 0.2 ) )
		{
			vec[2] = 3.14159265 - vec[2] ;
			cp = cos( vec[2] );			
			// Y
			s = mtx[3][1] / cp;
			c = mtx[3][3] / cp;
			vec[1] = atan2( s , c) ;

			// Z
			s = mtx[1][2] / cp;
			c = mtx[2][2] / cp;
			vec[3] = atan2( s , c);			
		}		
	}
	else
	{
		vec[1] = 0.0;
		vec[3] = atan2( mtx[1][3], mtx[2][3]);
		val = vec[2]+1.57080 ;
		if( -0.000001 < val &&  val < 0.000001 )
		{
			vec[1] = -vec[1];
			vec[2] = -vec[2];
			vec[3] = -vec[3];
		}
    }
    vTemp = vec ;
    return vTemp ;
}

matrix_print: mtx 
{
	info( "(" , mtx[1][1] , " , " , mtx[1][2] , " , "  , mtx[1][3] , " , "  , mtx[1][4], ")-(" ,
	            mtx[2][1] , " , " , mtx[2][2] , " , "  , mtx[2][3] , " , "  , mtx[2][4], ")-(" ,
	            mtx[3][1] , " , " , mtx[3][2] , " , "  , mtx[3][3] , " , "  , mtx[3][4], ")-(" ,
	            mtx[4][1] , " , " , mtx[4][2] , " , "  , mtx[4][3] , " , "  , mtx[4][4], ")" );
}

vector_print: vec
{
	info( "(" , vec.x , " , " , vec.y , " , "  , vec.z , ")" );
}


