//-----------------------------------------
// ATPastePoseAdv -- LScript Genetic
// Noboru Fujiyama 2003/05/27
//                 2003/09/25  add Automaton Model
//  Load lrt file 
//parameter 
//  Load Local Rot file : load file name 
@version 2.5
@script generic
@name ATLoadPose

@define AUTOMATON_VER 2.5
@define LAST_DIR "LastDir_Pose"

s_ItemNum;
s_asPanelItemNames;
s_asItemNames;
s_avRots;
s_avTrans;
a_anOutputFlag ;

s_IKMode = true ;
s_nValueChk = 2 ;
s_nIKChk = 1 ;
s_nSymmetry = 2 ;

/* Node ViewOn/Off Flag */
s_nFingerFlg = 0 ;
s_nUpperFlg = 1 ;
s_nLowerFlg = 1 ;
s_nCtrlFlg=1;

/* searchItem */
s_xSearchItem = nil ;

@define TYPE_AM  1 /* Automaton */
@define TYPE_MB  2 /* MotionBuilderCharacterize */
s_xParentItem ;
s_nTypeFlag = TYPE_AM ;

/* Automaton */
s_asRotHand = @"R_Thumb1"    ,"R_Thumb2"    ,"R_Thumb3"    ,
			"R_Index1"    ,"R_Index2"    ,"R_Index3"    ,
			"R_Middle1"   ,"R_Middle2"   ,"R_Middle3"   ,
			"R_Ring1"     ,"R_Ring2"     ,"R_Ring3"     ,
			"R_Pinky1"    ,"R_Pinky2"    ,"R_Pinky3"    ,
				               
			"L_Thumb1"    ,"L_Thumb2"    ,"L_Thumb3"    ,
			"L_Index1"    ,"L_Index2"    ,"L_Index3"    ,
			"L_Middle1"   ,"L_Middle2"   ,"L_Middle3"   ,
			"L_Ring1"     ,"L_Ring2"     ,"L_Ring3"     ,
			"L_Pinky1"    ,"L_Pinky2"    ,"L_Pinky3"    @;

s_asUpperArray = @"L_Shoulder2_IKNull","R_Shoulder2_IKNull",
			"R_Shoulder","R_NFS_IK1","R_NFS_IK2","R_Shoulder2","R_ArmDir","R_Arm","R_Elbow","R_ForeArm","R_ForearmDir","R_HandDir","R_Hand","R_Hand_Tip","R_ForearmDir_IKNull",
			"L_Shoulder","L_NFS_IK1","L_NFS_IK2","L_Shoulder2","L_ArmDir","L_Arm","L_Elbow","L_ForeArm","L_ForearmDir","L_HandDir","L_Hand","L_Hand_Tip","L_ForearmDir_IKNull",
			"RootSpin","Spine1","Spine2","Spine3","NeckNull","Neck","Head",
			"L_ArmGoal","R_ArmGoal","HeadGoal",
			 "R_Shoulder_a","R_ShoulderCtr","L_Shoulder_a","L_ShoulderCtr" ,
			 "Neck_a"   ,"Neck_b"    ,"Neck_c" ,"Neck_d"  ,"Neck_e"      ,"Neck_f"       ,"Neck_g",
			 "Spine_a"  ,"Spine_b"   ,"Spine_c", "L_ArmTipGoal","R_ArmTipGoal","L_ArmRot","R_ArmRot"@;
			

s_asLowerArray = @"L_Hip2_IKNull","R_Hip2_IKNull","L_FtTipGoal","R_FtTipGoal","L_FtRot","R_FtRot",
			 "R_Hip","R_Hip2","R_LegDir","R_Thigh","R_Knee","R_Shin","R_FootDir","R_Foot","R_FootTip",
			 "L_Hip","L_Hip2","L_LegDir","L_Thigh","L_Knee","L_Shin","L_FootDir","L_Foot","L_FootTip",
			 "R_HipNull","R_HipNFS_IK1","R_HipNFS_IK2",
			 "L_HipNull","L_HipNFS_IK1","L_HipNFS_IK2",
			 "Root","R_FtCtrl","L_FtCtrl","HeadGoal",
			 "R_Hip_a"  ,"R_HipCtr"  ,"L_Hip_a","L_HipCtr",
			 "Tail_a"   ,"Tail_b"    ,"Tail_c" ,"Tail_d"  ,"Tail_e"      ,"Tail_f"       ,"Tail_g","Tail_Null","Tail_Start"@;


s_asGlobalTRName = @"Root","L_ArmGoal","R_ArmGoal","R_FtCtrl","L_FtCtrl","HeadGoal","Tail_IKCtrl"@;

/*MotionBuilderCharacterize*/
s_asRotHandMB = 
			@"RightHandThumb1"    ,"RightHandThumb2"    ,"RightHandThumb3"    ,
			 "RightHandIndex1"    ,"RightHandIndex2"    ,"RightHandIndex3"    ,
			 "RightHandMiddle1"   ,"RightHandMiddle2"   ,"RightHandMiddle3"   ,
			 "RightHandRing1"     ,"RightHandRing2"     ,"RightHandRing3"     ,
			 "RightHandPinky1"    ,"RightHandPinky2"    ,"RightHandPinky3"    ,
				               
			 "LeftHandThumb1"    ,"LeftHandThumb2"    ,"LeftHandThumb3"    ,
			 "LeftHandIndex1"    ,"LeftHandIndex2"    ,"LeftHandIndex3"    ,
			 "LeftHandMiddle1"   ,"LeftHandMiddle2"   ,"LeftHandMiddle3"   ,
			 "LeftHandRing1"     ,"LeftHandRing2"     ,"LeftHandRing3"     ,
			 "LeftHandPinky1"    ,"LeftHandPinky2"    ,"LeftHandPinky3"    @;

s_asUpperArrayMB = 
			@"LeftShoulder2_IKNull","RightShoulder2_IKNull",
			 "RightShoulder","RightNFS_IK1","RightNFS_IK2","RightShoulder2","RightArmDir","RightArm","RightForeArm","RightForearmDir","RightHandDir","RightHand","RightHand_Tip","RightForearmDir_IKNull",
			 "LeftShoulder","LeftNFS_IK1","LeftNFS_IK2","LeftShoulder2","LeftArmDir","LeftArm","LeftForeArm","LeftForearmDir","LeftHandDir","LeftHand","LeftHand_Tip","LeftForearmDir_IKNull",
			 "HipsSpin","Spine","Spine1","Spine2","Spine3","NeckNull","Neck","Head",
			 "L_ArmGoal","R_ArmGoal","HeadGoal",
			 "Neck1"   ,"Neck2"    ,"Neck3" ,"Neck4"  ,"Neck5"      ,"Neck6"       ,"Neck7",
			 "Spine4"  ,"Spine5"   ,"Spine6", "L_ArmTipGoal","R_ArmTipGoal","L_ArmRot","R_ArmRot"@;
			

s_asLowerArrayMB = @"LeftHip2_IKNull","RightHip2_IKNull","L_FtTipGoal","R_FtTipGoal","L_FtRot","R_FtRot",
			 "RightHip","RightHip2","RightLegDir","RightUpLeg","RightLeg","RightFootDir","RightFoot","RightToeBase",
			 "LeftHip","LeftHip2","LeftLegDir","LeftUpLeg","LeftLeg","LeftFootDir","LeftFoot","LeftToeBase",
			 "RightHipNull","RightHipNFS_IK1","RightHipNFS_IK2",
			 "LeftHipNull" ,"LeftHipNFS_IK1" ,"LeftHipNFS_IK2",
			 "Hips","R_FtCtrl","L_FtCtrl","HeadGoal",
			 "Tail1"   ,"Tail2"    ,"Tail3" ,"Tail4"  ,"Tail5"      ,"Tail6"       ,"Tail7","Tail_Null","Tail_Start"@;

s_asGlobalTRNameMB = @"Hips","L_ArmGoal","R_ArmGoal","R_FtCtrl","L_FtCtrl","HeadGoal","Tail_IKCtrl"@;


generic 
{
	curScene = Scene();
	curItem = curScene.firstSelect();
	if( curItem == nil)
	{
		error("<br>You must select something before performing this operation." );
		return;		
	}
	/* seek Top Item  */
	s_xParentItem = curItem ;
	while( nil != s_xParentItem.parent )
	{
		s_xParentItem = s_xParentItem.parent ;
	}	
	if( 0 == ( s_nTypeFlag = check_item( s_xParentItem , 6 ) ) )
	{
		error("<br>You must select Automaton character Item ." );
		return;		
	}

	sFilePath = getdir("Content") + "\\temp\\localrot" + "\\_tempPose.lrt";

	reqbegin("ATLoadPose " + AUTOMATON_VER );
    reqsize(314,158);
    //
    var lastDir = globalrecall(LAST_DIR,"");
    var scenesDir = getdir("Scenes");
    var contentDir = getdir("Content");
    var dir = "";
    if( fileexists(lastDir) )
    {
        dir = lastDir;
    }
    else if( fileexists(scenesDir) )
    {
        dir = scenesDir;
	}
    else if( fileexists( contentDir ) )
    {
        dir = contentDir;
    }
	c0 = ctlcheckbox("Paste Mode", s_IKMode );
	c1 = ctlfilename("Pose File", dir , 30 , 1 );
    c2 = ctlchoice("Check Value",s_nValueChk,@"Yes","No"@);
    c3 = ctlchoice("Load IK control",s_nIKChk,@"Yes","No"@);
    c4 = ctlchoice("symmetry",s_nSymmetry,@"Yes","No"@);
	ctlactive( c0 , "toggle_on" ,c1 );
    return if !reqpost();

	nPasetBuffer = getvalue(c0);
	if( nPasetBuffer == false )
	{
		fileName = getvalue(c1);
	}
	else {
		fileName = sFilePath ;
	}
	s_nValueChk = getvalue(c2);
	s_nIKChk = getvalue(c3);
	s_nSymmetry = getvalue(c4);
	
	reqend();
	
	if((textFile = File(fileName)) == nil)
	{
		info( "Could not open file ! Try Paste Buffer" );
		fileName = sFilePath  ;
		if((textFile = File(fileName)) == nil)
		{
			error("Could not open file ", fileName );
			return;		
		}
	} 

	line = nil;
	s_ItemNum=1 ;
	while( textFile.eof() != true)
	{
		line = textFile.read();
		items = parse(":",line);
		if( items.count() > 1 )
		{
			if( 3 > items.count() )
			{
				s_asItemNames[s_ItemNum] = items[1] ;
				s_asPanelItemNames[s_ItemNum] = "*:" +  items[1] ;
				s_avRots[s_ItemNum] = vector( items[2] ) ;
				s_avTrans[s_ItemNum] = nil ;
				s_ItemNum++ ;
			}
			else {
				s_IKMode = true ;
				s_asItemNames[s_ItemNum] = items[1] ;
				s_asPanelItemNames[s_ItemNum] = "*:" + items[1] ;
				s_avRots[s_ItemNum] = vector( items[5] ) ;
				s_avTrans[s_ItemNum] = vector( items[3] ) ;
				s_ItemNum++ ;
			}
		}
	}

	if( s_nTypeFlag == TYPE_AM )
	{
		s_nFingerFlg = on_off_mng( s_nFingerFlg , s_asRotHand );
	}
	else if( s_nTypeFlag == TYPE_MB )
	{
		s_nFingerFlg = on_off_mng( s_nFingerFlg , s_asRotHandMB );
	}
	
	if( true == s_IKMode )
	{
		while( nil != curItem.parent )
		{
			curItem = curItem.parent ;
		}		
		curItem = select_by_name( curItem , "Master" );
	}
	reqbegin("ATLoadPose " + AUTOMATON_VER );
	ctllistbox("Load Bone Items" , 300 , 300 , "lb_count","lb_name","lb_event");
	c1 = ctlbutton( "Finger", 60 , "button_callback_c1" );
	c2 = ctlbutton( "Upper" , 60 , "button_callback_c2" );
   	c3 = ctlbutton( "Lower" , 60 , "button_callback_c3" );
   	c4 = ctlbutton( "Ctrl"  , 60 , "button_callback_c4" );
    ctlposition(c1,10,310 );	
    ctlposition(c2,10+62 ,310 );	
    ctlposition(c3,10+62+62 ,310 );	
    ctlposition(c4,10+62+62+62 ,310 );	
    if( s_nValueChk == true )
    { 	
    	c6 = ctltext( "" , "ValueChk Mode" );
	    ctlposition(c6,10,340 );	
    }
    if( s_nIKChk == true )
    {
		c7 = ctltext( "" , "Load IKCtrel Translation" );
		ctlposition(c7,10,360 );	
	}
    if( s_nSymmetry == true )
    {
		c5 = ctltext( "" , "Symmetry Mode" );
 		ctlposition( c5 , 10 , 380 );
    }	
	return if !reqpost();

	reqend();

	// OutputFlag Setting 
	for( nLoop = 1 ; nLoop <= s_asPanelItemNames.size() ; nLoop++ )
	{
		lines = parse(":", s_asPanelItemNames[ nLoop ]);
		if( "*" == lines[1] )
		{
			a_anOutputFlag[ nLoop ] = 1 ;
		}
		else {
			a_anOutputFlag[ nLoop ] = 0 ;
		}
		s_asPanelItemNames[ nLoop ] = lines[2];
	}

	// Create Key 
	nTime = curScene.currenttime ;

	SymmetryNameToId(curItem,nTime,s_nSymmetry);

	RefreshNow();
}

toggle_on:value
{
	return !value ;
}
check_item: xTop,nNum
{
	for( i = 1 ; i <= nNum ; i++ )
	{
		s_xSearchItem = nil ;
		searchItem( xTop , s_asGlobalTRName[ i ] );
		if( s_xSearchItem == nil )
		{
			for( i = 1 ; i <= nNum ; i++ )
			{
				s_xSearchItem = nil ;
				searchItem( xTop , s_asGlobalTRNameMB[ i ] );
				if( s_xSearchItem == nil )
				{
					return 0;
				}
			}
			return TYPE_MB ;
		}		
	}
	return TYPE_AM  ;
}
cheak_item_output : nSymmetryFlag , name 
{
	if( -1 == nSymmetryFlag )
	{
		for( nLoop = 1 ; nLoop <= s_asPanelItemNames.size() ; nLoop++ )
		{
			if( name == s_asPanelItemNames[ nLoop ] )
			{
				return a_anOutputFlag[ nLoop ];
			}
		}
	}
	else {
		return a_anOutputFlag[ nSymmetryFlag ];
	}
	return 0 ;
}

SymmetryNameToId : rootObj,time , nSymmetry
{
	for( no = 1 ; no < s_ItemNum ; no++ )
	{
		vRot = <0,0,0>;
		vRot = s_avRots[no] ;
		sName = s_asItemNames[no] ;
		nSymmetryFlag = no ;
		if( 1 == nSymmetry )
		{
			sTempName = s_asItemNames[no]  ;
			sPre = strleft( s_asItemNames[no] , 2 );
			if( sPre == "R_" )
			{
				sTemp = strright( s_asItemNames[no] , size( s_asItemNames[no] ) - 2 ); 
				sName = "L_" + sTemp ;
				nSymmetryFlag = -1 ;
			}
			else if( sPre == "L_" ) 
			{
				sTemp = strright( s_asItemNames[no] , size( s_asItemNames[no] ) - 2 ); 
				sName = "R_" + sTemp  ;
				nSymmetryFlag = -1 ;
			}
			else if( s_nTypeFlag == TYPE_MB )
			{
				sPre1 = strleft( s_asItemNames[no] , 5 );
				sPre2 = strleft( s_asItemNames[no] , 4 );
				if( sPre1 == "Right" )
				{
					sTemp = strright( s_asItemNames[no] , size( s_asItemNames[no] ) - 5 ); 
					sName = "Left" + sTemp ;
					nSymmetryFlag = -1 ;
				}
				else if( sPre2 == "Left" ) 
				{
					sTemp = strright( s_asItemNames[no] , size( s_asItemNames[no] ) - 4 ); 
					sName = "Right" + sTemp  ;
					nSymmetryFlag = -1 ;
				}
				
			}
			if( "HipsSpin" != sTempName )
			{
				fX = -1 * s_avRots[no].x ; 
				fZ = -1 * s_avRots[no].z ; 
				vRot = <fX,vRot.y,fZ>;
			}
			else {
				fX = 180.0 - ( s_avRots[no].x - 180.0 ) ; 
				fZ = -1 * s_avRots[no].z ; 
				vRot = <fX,vRot.y,fZ>;
			}
		}
		if( 1 == cheak_item_output( nSymmetryFlag , sName ) )
		{ 
			xName = parse( " (" , rootObj.name ) ;
			if( xName[ 1 ] == sName )
			{
				if( nil != s_avTrans[no] && s_nIKChk == 1 )
				{
					createKeys( rootObj , nil , vRot , nil , time );
					vTrans = s_avTrans[no] ;
					if( 1 == nSymmetry )
					{
						fX = -1 * s_avTrans[no].x ; 
						vTrans = <fX,vTrans.y,vTrans.z>;					
					}
					createKeys( rootObj , vTrans , nil , nil ,time );
				}
				else if( nil == s_avTrans[no] )
				{
					createKeys( rootObj , nil , vRot , nil , time );
				}
			}
		}
	}
	childObj = rootObj.firstChild();
	while(childObj)
	{
		SymmetryNameToId(childObj,time,nSymmetry);
		childObj = rootObj.nextChild();
	}
}

// Node View CallBack
button_callback_c1 
{
	if( s_nTypeFlag == TYPE_AM )
	{
		s_nFingerFlg = on_off_mng( s_nFingerFlg , s_asRotHand );
	}
	else if( s_nTypeFlag == TYPE_MB )
	{
		s_nFingerFlg = on_off_mng( s_nFingerFlg , s_asRotHandMB );
	}
	requpdate() ;	
}

button_callback_c2
{
	if( s_nTypeFlag == TYPE_AM )
	{
		s_nUpperFlg = on_off_mng( s_nUpperFlg , s_asUpperArray );
	}
	else if( s_nTypeFlag == TYPE_MB )
	{
		s_nUpperFlg = on_off_mng( s_nUpperFlg , s_asUpperArrayMB );
	}	
	requpdate() ;	
}

button_callback_c3 
{
	if( s_nTypeFlag == TYPE_AM )
	{
		s_nLowerFlg = on_off_mng( s_nLowerFlg , s_asLowerArray );
	}
	else if( s_nTypeFlag == TYPE_MB )
	{
		s_nLowerFlg = on_off_mng( s_nLowerFlg , s_asLowerArrayMB );
	}	
	requpdate() ;	
}
button_callback_c4 
{
	if( s_nTypeFlag == TYPE_AM )
	{
		s_nCtrlFlg = on_off_mng( s_nCtrlFlg , s_asGlobalTRName );
	}
	else if( s_nTypeFlag == TYPE_MB )
	{
		s_nCtrlFlg = on_off_mng( s_nCtrlFlg , s_asGlobalTRNameMB );
	}	
	requpdate() ;	
}
on_off_mng : nFlag , sNameArry
{
	for( nLoop = 1 ; nLoop <= s_asPanelItemNames.size() ; nLoop++ )
	{
		lines = parse(":",s_asPanelItemNames[nLoop]);
		xName = parse( " (" , lines[2] ) ;
		if( check_include( xName[1] , sNameArry ) )
		{
			if( nFlag )
			{
				s_asPanelItemNames[nLoop] = "*:" + lines[2] ;
			}
			else {
				s_asPanelItemNames[nLoop] = " :" + lines[2] ;
			}
		}
	}
	if( 0 == nFlag ) nFlag = 1 ;
	else nFlag = 0 ;
	return  nFlag ;
}

check_include : sName , asNameArray 
{

	for( nLoop = 1 ; nLoop <= asNameArray.size() ; nLoop++ )
	{
		if( asNameArray[ nLoop ] == sName ) return  true ; 
	}
	return  false ;
}

// Create Key
createKeys: newItem , vTrans , vRot , vScale ,time
{
	curChannel = newItem.firstChannel();

	while( nil != curChannel )
	{
		if( vTrans != nil )
		{
			if(curChannel.name == "Position.X")
			{
				crateKey( curChannel , time ,vTrans.x);
			}
			if(curChannel.name == "Position.Y")
			{
				crateKey( curChannel , time ,vTrans.y);
			}
			if(curChannel.name == "Position.Z")
			{
				crateKey( curChannel , time ,vTrans.z);
			}
		}
		if( vRot != nil )
		{
			if(curChannel.name == "Rotation.H")
			{
				crateKey( curChannel , time ,vRot.x);
			}
			if(curChannel.name == "Rotation.P")
			{
				crateKey( curChannel , time ,vRot.y);
			}
			if(curChannel.name == "Rotation.B")
			{
				crateKey( curChannel , time ,vRot.z);
			}
		}
		if( vScale != nil )
		{
			if(curChannel.name == "Scale.X")
			{
				crateKey( curChannel , time ,vScale.x);
			}
			if(curChannel.name == "Scale.Y")
			{
				crateKey( curChannel , time ,vScale.y);
			}
			if(curChannel.name == "Scale.Z")
			{
				crateKey( curChannel , time ,vScale.z);
			}			
		}
		curChannel = newItem.nextChannel();
	}
}

crateKey: xChanel , time , value  
{
	if( 1 == s_nValueChk )
	{
		temp = xChanel.value( time );
		if( value != temp ) 
		{
			xChanel.createKey( time ,value );
		}
	}
	else {
		xChanel.createKey( time ,value );
	}
}
lb_count
{
     return(s_asPanelItemNames.size());
}

lb_name: index
{
     return(s_asPanelItemNames[index]);
}

lb_event: items
{
	if(items != nil)
	{
		for( nLoop = 1 ; nLoop <= items.size() ; nLoop++ )
		{
			nIndex = items[ nLoop ];
			lines = parse(":",s_asPanelItemNames[nIndex]);
			if( "*" == lines[1] )
			{
				s_asPanelItemNames[nIndex] = " :" + lines[2] ;
			}
			else {
				s_asPanelItemNames[nIndex] = "*:" + lines[2] ;
			}
		}
		requpdate() ;
	}
}
/* select_by_name */
select_by_name: xRoot , sName 
{
	s_xSearchItem = nil ;
	xName = parse( " (" , xRoot.name ) ;
	if( sName == xName[ 1 ] )	
	{
		s_xSearchItem = xRoot ;
		return s_xSearchItem ;
	}
	searchItem( xRoot , sName ) ;
	if( nil != s_xSearchItem )
	{
		SelectItem( s_xSearchItem.id );
	}
	else {
		// info( "Item [" , sName , "] Not found!!  " , xRoot );
	}
	return s_xSearchItem ;
}
searchItem: s_xItem , sName 
{
	// use s_xSearchItem 
	xMesh = s_xItem.firstChild();
	while( xMesh )
	{
		xName = parse( " (" , xMesh.name ) ;
		if( sName == xName[ 1 ] )
		{
			s_xSearchItem  = xMesh ;		
			return ;
		}
		else {
			searchItem( xMesh , sName  );
			if( nil != s_xSearchItem )
			{
				return ;		
			}
		}
		xMesh = s_xItem.nextChild();
	}
}
/**/
