//-----------------------------------------
// ATMuscle -- LScript Motion
// Noboru Fujiyama 2006/05/26
//  Muscle Scaling ( Not Directtion  )
// 2008/01/20 Add scale xz Powered by PowerlessUser 
@version 2.1
@script motion
@name ATMuscle

/* puah/pop seleced item */
s_nSelectedNum ;
s_axSelectedItem ;
s_xParentItem ;

/* searchItem */
s_xSearchItem = nil ;

@define AUTOMATON_VER 2.6

/********************************************/
select_by_name: xRoot , sName 
{
	s_xSearchItem = nil ;
	xName = parse( " (" , xRoot.name ) ;
	if( sName == xName[ 1 ] )	
	{
		s_xSearchItem = xRoot ;
		return s_xSearchItem ;
	}
	searchItem( xRoot , sName ) ;
	if( nil != s_xSearchItem )
	{
		SelectItem( s_xSearchItem.id );
	}
	else {
		// info( "Item [" , sName , "] Not found!!  " , xRoot );
	}
	return s_xSearchItem ;
}

add_select_by_name: xRoot , sName 
{
	s_xSearchItem = nil ;
	xName = parse( " (" , xRoot.name ) ;
	if( sName == xName[ 1 ] )	
	{
		s_xSearchItem = xRoot ;
		return s_xSearchItem ;
	}
	searchItem( xRoot , sName ) ;
	if( nil != s_xSearchItem )
	{
		AddToSelection( s_xSearchItem.id );
	}
	else {
		info( "Item [" , sName , "] Not found!!  " , xRoot );
	}
	return s_xSearchItem ;
}
searchItem: xItem , sName 
{
	xMesh = xItem.firstChild();
	while( xMesh )
	{
		xName = parse( " (" , xMesh.name ) ;
		if( sName == xName[ 1 ] )
		{
			s_xSearchItem  = xMesh ;		
			return ;
		}
		else {
			searchItem( xMesh , sName  );
			if( nil != s_xSearchItem )
			{
				return ;		
			}
		}
		xMesh = xItem.nextChild();
	}
}

/* push/pop seleced item  */
top_item: xSelected 
{
	s_xParentItem = xSelected ;
	while( nil != s_xParentItem.parent )
	{
		s_xParentItem = s_xParentItem.parent ;
	}
}


/****************************************************/
/****************************************************/
/****************************************************/
/****************************************************/
/// IKTerget item id
s_idTargetID = nil ;
/// src bone item id 
s_idSrcID = nil ;
/// src bone length
s_dLength = 0.0 ;
/// Muscle Flag
s_nVolumeConst = 0 ;
s_nVolume = 1.0 ;
/// load target
s_sTargetName = nil ;

target_select:idSrcID
{
	s_dLength = idSrcID.restlength ;
	xChild = idSrcID.firstChild();
	if( NULL != xChild )
	{
		if( s_idTargetID == nil )
		{
			s_idTargetID = xChild.goal ;
		}
	}

}

create: obj
{
	s_idSrcID = obj;
	top_item( s_idSrcID ) ;
	target_select( s_idSrcID );
}

destroy
{
}

flags
{
     return(AFTERIK);
}


process: ma, frame, time
{
	if( s_idSrcID == nil ) return ;
	if( s_sTargetName != nil )
	{
		s_idTargetID= select_by_name( s_xParentItem , s_sTargetName );
		if( nil != s_idTargetID ) s_sTargetName = nil ;
	}
	
	scale = ma.get( SCALING ,time);
	if( s_idTargetID != nil && s_sTargetName == nil )
	{
		vPos1 = s_idTargetID.getWorldPosition( time );
		vPos2 = s_idSrcID.getWorldPosition( time );
		dDiff = vmag( vPos1 - vPos2 ) ;
		if( s_dLength != 0.0 )
		{
			scale.z = dDiff / s_dLength  ;
			if (scale.z != 0.0 &&  s_nVolumeConst != 0 )
			{
				workScale = sqrt(1 / ( scale.z ) );
				scale.x = pow( workScale , s_nVolume ) ;
				scale.y = pow( workScale , s_nVolume )  ;
			}			
			ma.set(SCALING,<scale.x,scale.y,scale.z>);
		}
	}
}
opt_active: value 
{
	return value  ;
}


options
{
    reqbegin("ATMuscle 2.2");
    reqsize(372,114);

    c1 = ctlmeshitems("Target ",s_idTargetID);
    ctlposition(c1,8,5);
    c2 = ctlcheckbox("VolumeConst ", s_nVolumeConst );
    c3 = ctlnumber(  "VolumePower" , s_nVolume );
    ctlposition(c2, 8    , 30      , 120 , 20 );
    ctlposition(c3, 8    , 30+24   , 120 , 20 );
    ctlactive( c2 , "opt_active" , c3 );
    return if !reqpost();

    s_idTargetID = getvalue(c1);
    s_nVolumeConst = getvalue(c2);
    s_nVolume = getvalue(c3); 
}

load: what, io
{
	if(what == SCENEMODE)
	{
		line = nil;
		while( line == nil && io.eof() != true) line = io.read();
		/// TargetItemId 
		items = parse(" ",line);
		if( items[1] == "Target" )
		{
			 s_sTargetName = items[2] ;
			 s_idTargetID = nil ;
		}
		/// Muscle flag
		line = io.read();
		items = parse(" ",line);
		if( items[1] == "VolumeConst" ) s_nVolume = number( items[2] );

		if( s_nVolume == 0 ) s_nVolumeConst = 0 ;
		else s_nVolumeConst = 1 ;
		
		if( s_idSrcID != nil ) s_dLength = s_idSrcID.restlength ;
	}
}

save: what, io
{
	if(what == SCENEMODE)
	{
		io.writeln("Target ", s_idTargetID.name );
		if( s_nVolumeConst != 0 )
		{
			io.writeln("VolumeConst " , s_nVolume );
		}
		else {
			io.writeln("VolumeConst " , s_nVolumeConst );
		}
	}	
}

