//-----------------------------------------
// ATSaveHmot -- LScript Genetic
// Noboru Fujiyama 2003/10/04
// 
//   Save .hmot AutomationRig/(AutoCharcterSetup3b mitaiou )  
// 
// parameter
// 2.01 Type1 Elbow ErrBugFix 2005/02/21
@version 2.5
@script generic
@name ATSaveHmot

@define AUTOMATON_VER 2.2


//@insert "Z:/LightWave/Programs/Plugins/add_plugin/NoboUtility/NCommon.lsi"
@define LAST_DIR "LastDir_Pose"

sMaster = @"Master"@;

sGlobalTRName = @"Root","L_ArmGoal","R_ArmGoal","R_FtCtrl","L_FtCtrl","HeadGoal","Tail_IKCtrl"@;

sAMGlobalLBankIKFK  = @"L_Shoulder2_IKNull","R_Shoulder2_IKNull","L_Hip2_IKNull","R_Hip2_IKNull"@;
sAcs3bGlobalLBankIKFK = @"R_Arm_[IKNull]","L_Arm_[IKNull]","R_Thigh_[IKNull]","L_Thigh_[IKNull]"@;

sGlobalLName  = @"L_FtTipGoal","R_FtTipGoal","L_FtRot","R_FtRot"@;

sAMRotName   =  @"R_Shoulder","R_NFS_IK1","R_NFS_IK2","R_Shoulder2","R_ArmDir","R_Elbow","R_Arm","R_ForeArm","R_ForearmDir","R_HandDir","R_Hand","R_Hand_Tip","R_ForearmDir_IKNull",
				 "L_Shoulder","L_NFS_IK1","L_NFS_IK2","L_Shoulder2","L_ArmDir","L_Elbow","L_Arm","L_ForeArm","L_ForearmDir","L_HandDir","L_Hand","L_Hand_Tip","L_ForearmDir_IKNull",
				 "R_Hip","R_HipNull","R_HipNFS_IK1","R_HipNFS_IK2","R_Hip2","R_LegDir","R_Thigh","R_Knee","R_Shin","R_FootDir","R_Foot","R_FootTip",  
				 "L_Hip","L_HipNull","L_HipNFS_IK1","L_HipNFS_IK2","L_Hip2","L_LegDir","L_Thigh","L_Knee","L_Shin","L_FootDir","L_Foot","L_FootTip",
				 "RootSpin","Spine1","Spine2","Spine3","NeckNull","Neck","Head",
				 "R_Hip_a"  ,"R_HipCtr"  ,"L_Hip_a","L_HipCtr","R_Shoulder_a","R_ShoulderCtr","L_Shoulder_a","L_ShoulderCtr"   ,
				 "Neck_a"   ,"Neck_b"    ,"Neck_c" ,"Neck_d"  ,"Neck_e"      ,"Neck_f"       ,"Neck_g",
				 "Tail_a"   ,"Tail_b"    ,"Tail_c" ,"Tail_d"  ,"Tail_e"      ,"Tail_f"       ,"Tail_g","Tail_Null","Tail_Start",       
				 "Spine_a"  ,"Spine_b"   ,"Spine_c"@;

sAcs3bRotName = @"R_Shoulder","R_ArmDir","R_Arm","R_ForeArm","R_ForearmDir","R_HandDir","R_Hand",
					"L_Shoulder","L_ArmDir","L_Arm","L_ForeArm","L_ForearmDir","L_HandDir","L_Hand",
					"R_Hip","R_LegDir","R_Thigh","R_Shin","R_FootDir","R_Foot","R_FootTip",  
					"L_Hip","L_LegDir","L_Thigh","L_Shin","L_FootDir","L_Foot","L_FootTip",
					"Spine1","Spine2","Spine3","NeckNull","Neck","Head"@;

sRotHand   = @"R_Thumb1"    ,"R_Thumb2"    ,"R_Thumb3"    ,
				"R_Index1"    ,"R_Index2"    ,"R_Index3"    ,
				"R_Middle1"   ,"R_Middle2"   ,"R_Middle3"   ,
				"R_Ring1"     ,"R_Ring2"     ,"R_Ring3"     ,
				"R_Pinky1"    ,"R_Pinky2"    ,"R_Pinky3"    ,
					               
				"L_Thumb1"    ,"L_Thumb2"    ,"L_Thumb3"    ,
				"L_Index1"    ,"L_Index2"    ,"L_Index3"    ,
				"L_Middle1"   ,"L_Middle2"   ,"L_Middle3"   ,
				"L_Ring1"     ,"L_Ring2"     ,"L_Ring3"     ,
				"L_Pinky1"    ,"L_Pinky2"    ,"L_Pinky3"    @;

/* MotionBuilderCharacterize */
sGlobalLNameMB  = @"LeftShoulder2_IKNull","LeftShoulder2_IKNull","LeftHip2_IKNull","LeftHip2_IKNull","L_FtTipGoal","R_FtTipGoal","L_FtRot","R_FtRot",
				 "L_ArmRot","R_ArmRot", "L_ArmTipGoal","R_ArmTipGoal"@;
sMBRotName   =  @"RightShoulder","RightNFS_IK1","RightNFS_IK2","RightShoulder2","RightArmDir","RightArm","RightForeArm","RightForearmDir","RightHandDir","RightHand","RightHand_Tip","RightForearmDir_IKNull",
				 "LeftShoulder","LeftNFS_IK1","LeftNFS_IK2","LeftShoulder2","LeftArmDir","LeftArm","LeftForeArm","LeftForearmDir","LeftHandDir","LeftHand","LeftHand_Tip","LeftForearmDir_IKNull",
				 "RightHip","RightHipNull","RightHipNFS_IK1","RightHipNFS_IK2","RightHip2","RightLegDir","RightUpLeg","RightLeg","RightFootDir","RightFoot","RightToeBase",  
				 "LeftHip","LeftHipNull","LeftHipNFS_IK1","LeftHipNFS_IK2","LeftHip2","LeftLegDir","LeftUpLeg","LeftLeg","LeftFootDir","LeftFoot","LeftTorBase",
				 "Hips","HipsSpin","Spine","Spine1","Spine2","Spine3","NeckNull","Neck","Head",
				 "Neck1"   ,"Neck2"    ,"Neck3" ,"Neck4"  ,"Neck5"      ,"Neck6"       ,"Neck7",
				 "Tail1"   ,"Tail2"    ,"Tail3" ,"Tail4"  ,"Tail5"      ,"Tail6"       ,"Tail7","Tail_Null","Tail_Start",       
				 "Spine4"  ,"Spine5"   ,"Spine6"@;
				 
sMBRotHand   = @"RightHandThumb1"    ,"RightHandThumb2"    ,"RightHandThumb3"    ,
				"RightHandIndex1"    ,"RightHandIndex2"    ,"RightHandIndex3"    ,
				"RightHandMiddle1"   ,"RightHandMiddle2"   ,"RightHandMiddle3"   ,
				"RightHandRing1"     ,"RightHandRing2"     ,"RightHandRing3"     ,
				"RightHandPinky1"    ,"RightHandPinky2"    ,"RightHandPinky3"    ,
					               
				"LeftHandThumb1"    ,"LeftHandThumb2"    ,"LeftHandThumb3"    ,
				"LeftHandIndex1"    ,"LeftHandIndex2"    ,"LeftHandIndex3"    ,
				"LeftHandMiddle1"   ,"LeftHandMiddle2"   ,"LeftHandMiddle3"   ,
				"LeftHand_Ring1"    ,"LeftHandRing2"     ,"LeftHandRing3"     ,
				"LeftHandPinky1"    ,"LeftHandPinky2"    ,"LeftHandPinky3"    @;
var sGlobalLBankIKFK ;
var sRotName ;

//-----------------------------------------
// Insert Function -- LScript 
// Noboru Fujiyama 2003/09/25
// select_by_name( xRoot , sName  );
//		s_xSearchItem
// push_selected_item(),pop_selected_item()
//		s_nSelectedNum 
//		s_axSelectedIte
//		s_xParentItem ;
// createKeys() ;
// get_object_channel_group();
//		s_xChannelGrp

/* puah/pop seleced item */
s_nSelectedNum ;
s_axSelectedItem ;
s_xParentItem ;

/* searchItem */
s_xSearchItem = nil ;

// use get_object_channel_group 
var s_xChannelGrp = nil ;

/********************************************/
select_by_name: xRoot , sName 
{
	s_xSearchItem = nil ;
	xName = parse( " (" , xRoot.name ) ;
	if( sName == xName[ 1 ] )	
	{
		s_xSearchItem = xRoot ;
		return s_xSearchItem ;
	}
	searchItem( xRoot , sName ) ;
	if( nil != s_xSearchItem )
	{
		SelectItem( s_xSearchItem.id );
	}
	else {
		// info( "Item [" , sName , "] Not found!!  " , xRoot );
	}
	return s_xSearchItem ;
}

searchItem: xItem , sName 
{
	xMesh = xItem.firstChild();
	while( xMesh )
	{
		xName = parse( " (" , xMesh.name ) ;
		if( sName == xName[ 1 ] )
		{
			s_xSearchItem  = xMesh ;		
			return ;
		}
		else {
			searchItem( xMesh , sName  );
			if( nil != s_xSearchItem )
			{
				return ;		
			}
		}
		xMesh = xItem.nextChild();
	}
}

/* push/pop seleced item  */
push_selected_item:scene , xSelected 
{
	/* get selected item */
	for( s_nSelectedNum = 1 ; xSelected ; ++s_nSelectedNum )
	{
		s_axSelectedItem[ s_nSelectedNum ] = xSelected ;
		xSelected = scene.nextSelect();
	}
	/* seek Top Item  */
	s_xParentItem = s_axSelectedItem[ 1 ] ;
	while( nil != s_xParentItem.parent )
	{
		s_xParentItem = s_xParentItem.parent ;
	}
}

/* push/pop seleced item  */
pop_selected_item
{
	// select item 
	SelectItem( s_axSelectedItem[ 1 ].id );
	for( nLoop = 2 ; nLoop < s_nSelectedNum ; nLoop++ )
	{
		AddToSelection( s_axSelectedItem[ nLoop ].id );
	}
}
/* create keys */
createKeys: newItem , vTrans , vRot , vScale ,time
{
	curChannel = newItem.firstChannel();

	while( nil != curChannel )
	{
		if( vTrans != nil )
		{
			if(curChannel.name == "Position.X")
			{
				crateKey( curChannel , time ,vTrans.x);
			}
			if(curChannel.name == "Position.Y")
			{
				crateKey( curChannel , time ,vTrans.y);
			}
			if(curChannel.name == "Position.Z")
			{
				crateKey( curChannel , time ,vTrans.z);
			}
		}
		if( vRot != nil )
		{
			if(curChannel.name == "Rotation.H")
			{
				crateKey( curChannel , time ,vRot.x);
			}
			if(curChannel.name == "Rotation.P")
			{
				crateKey( curChannel , time ,vRot.y);
			}
			if(curChannel.name == "Rotation.B")
			{
				crateKey( curChannel , time ,vRot.z);
			}
		}
		if( vScale != nil )
		{
			if(curChannel.name == "Scale.X")
			{
				crateKey( curChannel , time ,vScale.x);
			}
			if(curChannel.name == "Scale.Y")
			{
				crateKey( curChannel , time ,vScale.y);
			}
			if(curChannel.name == "Scale.Z")
			{
				crateKey( curChannel , time ,vScale.z);
			}			
		}
		curChannel = newItem.nextChannel();
	}
}

crateKey: xChanel , time , value  
{
	if( 1 == s_nValueChk )
	{
		temp = xChanel.value( time );
		if( value != temp ) 
		{
			xChanel.createKey( time ,value );
		}
	}
	else {
		xChanel.createKey( time ,value );
	}
}

resetRotaionKeys:  xPrrentItem , sName  
{
	xItem = select_by_name( xPrrentItem , sName  );
	if( nil == xItem )
	{
		error( "Error "  , sName ) ;
	}
	else {
		
		curChannel = xItem.firstChannel();

		while( nil != curChannel )
		{
			if(curChannel.name == "Rotation.H" )
			{
				for( nLoop = 1 ; nLoop <=  curChannel.keyCount ; nLoop++ )
				{
					curChannel.setKeyValue( curChannel.keys[ nLoop ] , 0 );
				}
			}
			if(curChannel.name == "Rotation.P" )
			{
				for( nLoop = 1 ; nLoop <=  curChannel.keyCount ; nLoop++ )
				{
					curChannel.setKeyValue( curChannel.keys[ nLoop ] , 0 );
				}
			}
			curChannel = xItem.nextChannel();
		}
	}
}


/******************************************************/

get_object_channel_group : xSelected , sName 
{
	// use s_xChannelGrp; 
	xChannelGrp = ChannelGroup();
	s_xChannelGrp = nil ;
	object_channel_group( xSelected , xChannelGrp , sName  );
	return s_xChannelGrp ;
}

object_channel_group : xSelected , xChannelGrp , sName 
{	
	// use s_xChannelGrp; 
	while( xChannelGrp != nil )
	{
		if( xChannelGrp.parent.name == xSelected.name )
		{
			if( xChannelGrp.name == sName )
			{
				s_xChannelGrp = xChannelGrp ;
				break ;
			}
		}
		object_channel_group( xSelected , ChannelGroup(  xChannelGrp ) , sName  ) ;
		if( nil != s_xChannelGrp ) 
		{
			break ;
		}
		xChannelGrp = xChannelGrp.next();
	}
	return s_xChannelGrp ;
}

createChannelKeys: xGroup , sChannelName , time , value 
{
	curChannel = xGroup.firstChannel();

	while( nil != curChannel )
	{
		if(curChannel.name == sChannelName )
		{
			createKey( curChannel , time , value );
			break ;
		}
		curChannel = xGroup.nextChannel();
	}
}
createKey: xChanel , time , value  
{
	if( 1 == s_nValueChk )
	{
		temp = xChanel.value( time );
		if( value != temp ) 
		{
			xChanel.createKey( time ,value );
		}
	}
	else {
		xChanel.createKey( time ,value );
	}
}

/******************************************************/
/******************************************************/
var s_sFilename = "mot1.hmot";
var s_sActorName = "Actor";
var s_sMotionName = "Motion1";
var s_nStartFrames = 0;
var s_nEndFrames = 60;
var s_nStartRange = 0;
var s_nEndRange = 60;
				 
generic                     
{
	xScene = Scene();
	/* puah seleced item */
	xSelected = xScene.firstSelect();
	if( xSelected == nil)
	{
		error("<br>You must select Automaton character object" );
		return;		
	}
	push_selected_item( xScene , xSelected );
	curItem = select_by_name( s_xParentItem , "Master" );
	s_xParentItem = curItem ;
	xParentItem = s_xParentItem ;
	
	s_nStartRange = s_nStartFrames = xScene.framestart;
	s_nEndRange   = s_nEndFrames   = xScene.frameend;

	options();

	items = parse(".",s_sFilename);
	s_sFilename = items[1] + ".hmot" ;
	
	if((xFile = File( s_sFilename , "w" ) ) == nil)
	{
		error("Dos not open file ", fileName );
		return;		
	}
	var nIKFKFlag = 0 ;
	
	if( nil != select_by_name( xParentItem , "R_NFS_IK1" ) ) 
	{ 
		sGlobalLBankIKFK = sAMGlobalLBankIKFK ;
		sRotName         = sAMRotName ;	
	}
	else {
		sGlobalLBankIKFK = sAcs3bGlobalLBankIKFK ;
		sRotName         = sAcs3bRotName ;
	}
	
	if( nil != select_by_name( xParentItem , sGlobalLBankIKFK[ 1 ] ) ) nIKFKFlag = 1 ;

	if( nIKFKFlag == 1 )
	{
		nNum = sMaster.size() + sGlobalTRName.size()  + sGlobalLName.size() + sGlobalLBankIKFK.size() + sRotName.size() + sRotHand.size() ;
	}
	else {
		nNum = sMaster.size() + sGlobalTRName.size() + sGlobalLName.size() + sRotName.size() + sRotHand.size() ;
	}

	if( 0 == is_tyep2( xParentItem , sRotName )  )
	{
		nNum -= 4;
	}
	xFile.writeln( "MotionActor \"" , s_sActorName  , "\"" );	
	xFile.writeln( "MotionName \""  , s_sMotionName , "\"" );	
	xFile.writeln( "MotionRange "   , s_nStartRange , " " , s_nEndRange );	
	xFile.writeln( "MotionFrames "  , s_nStartFrames , " " , s_nEndFrames );
	xFile.writeln( "NumberOfItems "  , nNum  );

	output_hmot_table(  xFile , xParentItem , sMaster        ,  7 , 7 , 7 );
	output_hmot_table(  xFile , xParentItem , sGlobalTRName  ,  7 , 7 , 0 );
	output_hmot_table(  xFile , xParentItem , sGlobalLName ,  7 , 7 , 0 );
	output_hmot_table(  xFile , xParentItem , sRotName       ,  7 , 7 , 0 );
	output_hmot_table(  xFile , xParentItem , sRotHand     ,  7 , 7 , 0 );
	if( nil != select_by_name( xParentItem , sGlobalLBankIKFK[ 1 ] ) )
	{
		output_hmot_table(  xFile , xParentItem , sGlobalLBankIKFK   ,  0 , 4 , 0 );
	}

	xFile.close();
	
	pop_selected_item();
}

options
{
    reqbegin("AT Save hmot" + AUTOMATON_VER );
    reqsize(315,228);

    //
    var lastDir = globalrecall(LAST_DIR,"");
    var scenesDir = getdir("Scenes");
    var contentDir = getdir("Content");
    var dir = "";
    if( fileexists(lastDir) )
    {
        dir = lastDir;
    }
    else if( fileexists(scenesDir) )
    {
        dir = scenesDir;
	}
    else if( fileexists( contentDir ) )
    {
        dir = contentDir;
    }

    c1 = ctlfilename("Filename      ", dir );
    ctlposition(c1,20,15,192,19);

    c2 = ctlstring("Acter Name  ",s_sActorName);
    ctlposition(c2,22,51,192,18);

    c3 = ctlstring("Motion Name",s_sMotionName);
    ctlposition(c3,21,73,193,19);

    s1 = ctlsep(0,290 );
    ctlposition(s1,9,43);

    c4 = ctlinteger("StartFrames",s_nStartFrames);
    ctlposition(c4,13,101,125,20);

    c5 = ctlinteger("EndFrames",s_nEndFrames);
    ctlposition(c5,147,101,119,21);

    //c6 = ctlinteger("StartRange",s_nStartRange);
    //ctlposition(c6,19,128,120,21);

    //c7 = ctlinteger("EndRange",s_nEndRange);
    //ctlposition(c7,141,129,125,22);

    return if !reqpost();

    s_sFilename = getvalue(c1);
    s_sActorName = getvalue(c2);
    s_sMotionName = getvalue(c3);
    s_nStartFrames = getvalue(c4);
    s_nEndFrames = getvalue(c5);
    //s_nStartRange = getvalue(c6);
    //s_nEndRange = getvalue(c7);
    
    s_nStartRange = s_nStartFrames ;
    s_nEndRange =   s_nEndFrames ;
    reqend();
    
	path = split(s_sFilename);
	globalstore( LAST_DIR , path[1]+path[2] );
}

output_hmot_table:xFile , xParentItem , astable , nPos , nRot , nScale 
{
	for( nLoop = 1 ; nLoop <= astable.size() ; nLoop++ )
	{
		xItem = select_by_name( xParentItem , astable[ nLoop ] ) ;
		if( nil != xItem )
		{
			output_hmot_item( xFile , xItem , nPos , nRot , nScale  );
		}
		else {
			// error( "Table Error " ,  astable[ nLoop ] );
		}	
	}
}

is_tyep2: xParentItem , astable 
{
	for( nLoop = 1 ; nLoop <= astable.size() ; nLoop++ )
	{
		xItem = select_by_name( xParentItem , astable[ nLoop ] ) ;
		if( nil == xItem )
		{
			return 0;
		}
	}
	return 1 ;
}


is_output_channel: xChannel , nPos , nRot , nSacle 
{

	if(xChannel.name == "Position.X")
	{
		if( 1 == ( nPos & 1 ) ) return 1 ;
	}
	else if(xChannel.name == "Position.Y")
	{
		if( 2 == ( nPos & 2 ) ) return 1 ;
	}
	else if(xChannel.name == "Position.Z")
	{
		if( 4 == ( nPos & 4 ) ) return 1 ;
	}
	else if(xChannel.name == "Rotation.H")
	{
		if( 1 == ( nRot & 1 ) ) return 1 ;
	}
	else if(xChannel.name == "Rotation.P")
	{
		if( 2 == ( nRot & 2 ) ) return 1 ;
	}
	else if(xChannel.name == "Rotation.B")
	{
		if( 4 ==( nRot & 4 ) ) return 1 ;
	}
	else if(xChannel.name == "Scale.X")
	{
		if( 1 == ( nSacle & 1 ) ) return 1 ;
	}
	else if(xChannel.name == "Scale.Y")
	{
		if( 2 == ( nSacle & 2 ) ) return 1 ;
	}
	else if(xChannel.name == "Scale.Z")
	{
		if( 4 == ( nSacle & 4 ) ) return 1 ;
	}			
	return 0 ;
}


output_hmot_item:xFile , xItem , nPos , nRot , nScale  
{
	xFile.writeln( "{ Item" );	
	xFile.writeln( "  ItemName \"" , xItem.name , "\"" );	
	xFile.writeln( "  ItemState 1" ); // ????
	xFile.writeln( "  ItemChannels 9" ); // kimeuti

	xChannel = xItem.firstChannel(); 
	while( nil != xChannel )
	{
		if( 1 == is_output_channel( xChannel , nPos , nRot , nScale ) )
		{
			output_channel( xFile , xItem , xChannel );
		}
		else {
			output_channel_dmy( xFile , xItem , xChannel  );
		}
		
		if( xChannel.name == "Scale.Z" )
		{
			break ;
		}
		xChannel = xItem.nextChannel();
	}
	xFile.writeln( "}" ); 
}

output_channel:xFile, xSelected , xChannel 
{
	nCuraveTable[] = @0,1,0,4,0,3,0,0@;
	nType = xChannel.type + 1 ;
	xFile.writeln( "  { Channel" );
	xFile.writeln( "    ChannelName \"" , xSelected.name , ".",xChannel.name , "\"" );
	xFile.writeln( "    ChannelType " , nType );
	xFile.writeln( "    { Envelope" );
	xFile.writeln( "      " , xChannel.keyCount );
	for( nLoop = 1 ; nLoop <=  xChannel.keyCount ; nLoop++ )
	{
		fValue      = xChannel.getKeyValue( xChannel.keys[ nLoop ] );
		if( xChannel.name == "Rotation.H" || xChannel.name == "Rotation.P" || xChannel.name == "Rotation.B" )
		{
			fValue = ( fValue * 3.14159267 ) / 180.0 ;
		}
		fTime       = xChannel.getKeyTime( xChannel.keys[ nLoop ] );
		nCurave     = xChannel.getKeyCurve( xChannel.keys[ nLoop ] ) ;
		fTension    = xChannel.getKeyTension( xChannel.keys[ nLoop ] );
		fContinuity = xChannel.getKeyContinuity( xChannel.keys[ nLoop ] );
		fBias       = xChannel.getKeyBias( xChannel.keys[ nLoop ] );
		axParam     = xChannel.getKeyHermite( xChannel.keys[ nLoop ] );
		nCv = nCuraveTable[ nCurave ];
		xFile.writeln( "      Key " , fValue , " " , fTime , " " , nCv , " " , fTension , " " , fContinuity , " " , fBias , " " , axParam[4]  , " " , axParam[4] , " 0" );

	}
	xFile.writeln( "      Behaviors "  , xChannel.preBehavior , " " ,  xChannel.postBehavior );
	xFile.writeln( "    }" );
	xFile.writeln( "    ChannelState 1" );
	xFile.writeln( "  }" );
	
}

output_channel_dmy:xFile, xSelected , xChannel 
{
	nCuraveTable[] = @0,1,0,4,0,3,0,0@;
	nType = xChannel.type + 1 ;
	xFile.writeln( "  { Channel" );
	xFile.writeln( "    ChannelName \"" , xSelected.name , ".",xChannel.name , "\"" );
	xFile.writeln( "    ChannelType " , nType );
	xFile.writeln( "    { Envelope" );
	xFile.writeln( "      1" );
	xFile.writeln( "      0 0 0 0 0 0 0 0 0" );
	xFile.writeln( "      Behaviors "  , xChannel.preBehavior , " " ,  xChannel.postBehavior );
	xFile.writeln( "    }" );
	xFile.writeln( "    ChannelState 1" );
	xFile.writeln( "  }" );
	
}

