//-----------------------------------------
// ATIKCtrl -- LScript Genetic
// Noboru Fujiyama 2003/07/22
//                 2003/09/25  add Automaton Model
//  Acs3b/Automaton IK/FK On/Off etc 
@version 2.7
@script generic
@name IKBlendAutoBaker

@define AUTOMATON_VER 2.0

s_xFlag = 1 ;

// use get_object_channel_group 
var s_xChannelGrp = nil ;
/* use searchItem & select_by_name */
s_xSearchItem = nil ;

/* puah/pop seleced item */
s_nSelectedNum ;
s_axSelectedItem ;
s_xTop ;

var s_xItem ;

generic 
{
	xScene = Scene();	
	xSelected = xScene.firstSelect();	
	if(xSelected == nil)
	{
		error("<br>You must select something before performing this operation." );
		return;		
	}
	push_selected_item( xScene , xSelected );

	s_xTop = get_top_item( xSelected );
	
	xLArm = find_item( s_xTop , "L_IKBlendArm" ) ;
	xRArm = find_item( s_xTop , "R_IKBlendArm" ) ;
	xLLeg = find_item( s_xTop , "L_IKBlendLeg" ) ;
	xRLeg = find_item( s_xTop , "R_IKBlendLeg" ) ;
	
	var vVecLArm = xLArm.getPosition(xScene.currenttime ) ;	
	var vVecRArm = xRArm.getPosition(xScene.currenttime ) ;	
	var vVecLLeg = xLLeg.getPosition(xScene.currenttime ) ;	
	var vVecRLeg = xRLeg.getPosition(xScene.currenttime ) ;	

	nFlgLArm = 0 ; 
	nFlgRArm = 0 ; 
	nFlgLLeg = 0 ; 
	nFlgRLeg = 0 ; 

	if( vVecLArm.z == 1.0 ) nFlgLArm = 1 ;
	if( vVecRArm.z == 1.0 ) nFlgRArm = 1 ;
	if( vVecLLeg.z == 1.0 ) nFlgLLeg = 1 ;
	if( vVecRLeg.z == 1.0 ) nFlgRLeg = 1 ;
	
	reqbegin("Change AutoBake Mode" + AUTOMATON_VER );
    reqsize(160,160);

	cTex = ctltext("AutoBake" , " Attention! FK Key Overwight " );
	c1 = ctlcheckbox( "Left  Arm  " , nFlgLArm );
	c2 = ctlcheckbox( "Right Arm " , nFlgRArm );
	c3 = ctlcheckbox( "Left  Leg   " , nFlgLLeg );
	c4 = ctlcheckbox( "Right Leg  " , nFlgRLeg );

    return if !reqpost();

    nFlgLArmOut = getvalue(c1);
    nFlgRArmOut = getvalue(c2);
    nFlgLLegOut = getvalue(c3);
    nFlgRLegOut = getvalue(c4);
    
    if( nFlgLArmOut != nFlgLArm )
    {
		vVecLArm.z = nFlgLArmOut ;
		createKeys( xLArm , vVecLArm , nil , nil , xScene.currenttime );	
	}
    if( nFlgRArmOut != nFlgRArm )
    {
		vVecRArm.z = nFlgRArmOut ;
		createKeys( xRArm , vVecRArm , nil , nil , xScene.currenttime );	
	}
    if( nFlgLLegOut != nFlgLLeg )
    {
		vVecLLeg.z = nFlgLLegOut ;
		createKeys( xLLeg , vVecLLeg , nil , nil , xScene.currenttime );	
	}
    if( nFlgRLegOut != nFlgRLeg )
    {
		vVecRLeg.z = nFlgRLegOut ;
		createKeys( xRLeg , vVecRLeg , nil , nil , xScene.currenttime );	
	}		
    reqend();

	pop_selected_item() ;

}
/******************************************************/
get_object_channel_group : xSelected , sName 
{
	// use s_xChannelGrp; 
	xChannelGrp = ChannelGroup();
	s_xChannelGrp = nil ;
	object_channel_group( xSelected , xChannelGrp , sName  );
	return s_xChannelGrp ;
}

object_channel_group : xSelected , xChannelGrp , sName 
{	
	// use s_xChannelGrp; 
	while( xChannelGrp != nil )
	{
		if( xChannelGrp.parent.name == xSelected.name )
		{
			if( xChannelGrp.name == sName )
			{
				s_xChannelGrp = xChannelGrp ;
				break ;
			}
		}
		object_channel_group( xSelected , ChannelGroup(  xChannelGrp ) , sName  ) ;
		if( nil != s_xChannelGrp ) 
		{
			break ;
		}
		xChannelGrp = xChannelGrp.next();
	}
	return s_xChannelGrp ;
}

createChannelKeys: xGroup , sChannelName , time , value 
{
	curChannel = xGroup.firstChannel();

	while( nil != curChannel )
	{
		if(curChannel.name == sChannelName )
		{
			createKey( curChannel , time , value );
			break ;
		}
		curChannel = xGroup.nextChannel();
	}
}

createKey: xChanel , time , value  
{
	if( 1 == s_nValueChk )
	{
		temp = xChanel.value( time );
		if( value != temp ) 
		{
			xChanel.createKey( time ,value );
		}
	}
	else {
		xChanel.createKey( time ,value );
	}
}

deleteChannelKeys: xGroup , sChannelName , time  
{
	curChannel = xGroup.firstChannel();

	while( nil != curChannel )
	{
		if(curChannel.name == sChannelName )
		{
			for( nLoop = 1 ; nLoop <=  curChannel.keyCount ; nLoop++ )
			{
				
				if( time == curChannel.getKeyTime( curChannel.keys[ nLoop ] ) )
				{
					curChannel.deleteKey( curChannel.keys[ nLoop ] );
					break ;
				}
			}
			break ;
		}
		curChannel = xGroup.nextChannel();
	}
}

/* get_top_item  */
get_top_item : xSelected 
{
	/* seek Top Item  */
	xParentItem = xSelected ;
	while( nil != xParentItem.parent )
	{
		xParentItem = xParentItem.parent ;
	}
	return xParentItem ;
}

/********************************************/
select_by_name: xRoot , sName 
{
	// use s_xSearchItem 
	s_xSearchItem = nil ;
	xName = parse( " (" , xRoot.name ) ;
	if( sName == xName[ 1 ] )	
	{
		s_xSearchItem = xRoot ;
		return s_xSearchItem ;
	}
	searchItem( xRoot , sName ) ;
	if( nil != s_xSearchItem )
	{
		SelectItem( s_xSearchItem.id );
	}
	else {
		// info( "Item [" , sName , "] Not found!!  " , xRoot );
	}
	return s_xSearchItem ;
}
find_item: xRoot , sName 
{
	// use s_xSearchItem 
	s_xSearchItem = nil ;
	xName = parse( " (" , xRoot.name ) ;
	if( sName == xName[ 1 ] )	
	{
		s_xSearchItem = xRoot ;
		return s_xSearchItem ;
	}
	searchItem( xRoot , sName ) ;
	return s_xSearchItem ;
}

searchItem: s_xItem , sName 
{
	// use s_xSearchItem 
	xMesh = s_xItem.firstChild();
	while( xMesh )
	{
		xName = parse( " (" , xMesh.name ) ;
		if( sName == xName[ 1 ] )
		{
			s_xSearchItem  = xMesh ;		
			return ;
		}
		else {
			searchItem( xMesh , sName  );
			if( nil != s_xSearchItem )
			{
				return ;		
			}
		}
		xMesh = s_xItem.nextChild();
	}
}

/* push/pop seleced item  */
push_selected_item:scene , xSelected 
{
	/* get selected item */
	for( s_nSelectedNum = 1 ; xSelected ; ++s_nSelectedNum )
	{
		s_axSelectedItem[ s_nSelectedNum ] = xSelected ;
		xSelected = scene.nextSelect();
	}
	/* seek Top Item  */
	s_xParentItem = s_axSelectedItem[ 1 ] ;
	while( nil != s_xParentItem.parent )
	{
		s_xParentItem = s_xParentItem.parent ;
	}
}

/* push/pop seleced item  */
pop_selected_item
{
	// select item 
	SelectItem( s_axSelectedItem[ 1 ].id );
	for( nLoop = 2 ; nLoop < s_nSelectedNum ; nLoop++ )
	{
		AddToSelection( s_axSelectedItem[ nLoop ].id );
	}
}

createKeys: newItem , vTrans , vRot , vScale ,time
{
	curChannel = newItem.firstChannel();

	while( nil != curChannel )
	{
		if( vTrans != nil )
		{
			if(curChannel.name == "Position.X")
			{
				crateKey( curChannel , time ,vTrans.x);
			}
			if(curChannel.name == "Position.Y")
			{
				crateKey( curChannel , time ,vTrans.y);
			}
			if(curChannel.name == "Position.Z")
			{
				crateKey( curChannel , time ,vTrans.z);
			}
		}
		if( vRot != nil )
		{
			if(curChannel.name == "Rotation.H")
			{
				crateKey( curChannel , time ,vRot.x);
			}
			if(curChannel.name == "Rotation.P")
			{
				crateKey( curChannel , time ,vRot.y);
			}
			if(curChannel.name == "Rotation.B")
			{
				crateKey( curChannel , time ,vRot.z);
			}
		}
		if( vScale != nil )
		{
			if(curChannel.name == "Scale.X")
			{
				crateKey( curChannel , time ,vScale.x);
			}
			if(curChannel.name == "Scale.Y")
			{
				crateKey( curChannel , time ,vScale.y);
			}
			if(curChannel.name == "Scale.Z")
			{
				crateKey( curChannel , time ,vScale.z);
			}			
		}
		curChannel = newItem.nextChannel();
	}
}

crateKey: xChanel , time , value  
{
	if( 1 == s_nValueChk )
	{
		temp = xChanel.value( time );
		if( value != temp ) 
		{
			xChanel.createKey( time ,value );
		}
	}
	else {
		xChanel.createKey( time ,value );
	}
}


