//-----------------------------------------
// LoadLoaclRot -- LScript Genetic
// Noboru Fujiyama 2003/05/27
//  Load lrt file 
//  Only that whose name corresponds is adapted.
//parameter 
//  Load Local Rot file : load file name 
@version 2.5
@script generic
@name LoadLoaclRot 

@define AUTOMATON_VER 2.0

@define LAST_DIR "LastDir_Pose"

s_ItemNum;
s_asItemNames;
s_avRots;
s_avTrans;

s_nValueChk;
s_nIKChk;
s_nSymmetry ;

s_IKMode = false ;


generic 
{
	curScene = Scene();
	xSelected = curScene.firstSelect();	
	if(xSelected == nil)
	{
		error("<br>You must select something before performing this operation." );
		return;		
	}
	
	s_nValueChk = 2 ;
	s_nIKChk = 2 ;
	s_nSymmetry = 2 ;
	


	reqbegin("Load Local Rot " + AUTOMATON_VER );
    reqsize(314,158);
    //
    var lastDir = globalrecall(LAST_DIR,"");
    var scenesDir = getdir("Scenes");
    var contentDir = getdir("Content");
    var dir = "";
    if( fileexists(lastDir) )
    {
        dir = lastDir;
    }
    else if( fileexists(scenesDir) )
    {
        dir = scenesDir;
	}
    else if( fileexists( contentDir ) )
    {
        dir = contentDir;
    }

	c1 = ctlfilename("Load Local Rot file",dir, 30 , 1 );

    c2 = ctlchoice("Check Value",s_nValueChk,@"Yes","No"@);

    c3 = ctlchoice("Load IK control",s_nIKChk,@"Yes","No"@);

    c4 = ctlchoice("symmetry",s_nSymmetry,@"Yes","No"@);

    return if !reqpost();

	fileName = getvalue(c1);
	s_nValueChk = getvalue(c2);
	s_nIKChk = getvalue(c3);
	s_nSymmetry = getvalue(c4);

    reqend();

	path = split(fileName);
	globalstore( LAST_DIR , path[1]+path[2] );

	
	if((textFile = File(fileName)) == nil)
	{
		error("Could not open file ", fileName );
		return;		
	} 

	line = nil;
	s_ItemNum=1 ;
	while( textFile.eof() != true)
	{
		line = textFile.read();
		items = parse(":",line);
		if( items.count() > 1 )
		{
			if( 3 > items.count() )
			{
				s_asItemNames[s_ItemNum] = items[1] ;
				s_avRots[s_ItemNum] = vector( items[2] ) ;
				s_avTrans[s_ItemNum] = nil ;
				s_ItemNum++ ;
			}
			else {
				s_IKMode = true ;
				s_asItemNames[s_ItemNum] = items[1] ;
				s_avRots[s_ItemNum] = vector( items[5] ) ;
				s_avTrans[s_ItemNum] = vector( items[3] ) ;
				s_ItemNum++ ;
			}
		}
	}

	reqbegin("Load Bone Items " + AUTOMATON_VER );
    reqsize(350,400);	
	ctllistbox("Load Bone Items" , 300 , 300 , "lb_count","lb_name");
	if( true == s_IKMode )
	{
		c3 = ctlcheckbox("IK Mode",s_IKMode);
	    ctlposition(c3,10,310 );
	}
	return if !reqpost();
	if( true == s_IKMode )
	{
		s_IKMode = getvalue(c3);
	}
	reqend();
		
	if( true == s_IKMode )
	{
		while( nil != xSelected.parent )
		{
			xSelected = xSelected.parent ;
		}	
		nameToId(xSelected,curScene.currenttime);
	}
	else {
		/* 2003/07/11 malty Itme saport */
		for( s_nSelectedNum = 1 ; xSelected ; ++s_nSelectedNum )
		{
			nameToId(xSelected,curScene.currenttime);
			xSelected = curScene.nextSelect();
		}	
	}
	reqend();
	
	RefreshNow();
}

nameToId : rootObj,time
{
	for( no = 1 ; no < s_ItemNum ; no++ )
	{
		vRot = s_avRots[no] ;
		sName = s_asItemNames[no] ;
		if( 1 == s_nSymmetry )
		{
			sPre = strleft( s_asItemNames[no] , 2 );
			if( sPre == "R_" )
			{
				sTemp = strright( s_asItemNames[no] , size( s_asItemNames[no] ) - 2 ); 
				sName = "L_" + sTemp ;
			}
			else if( sPre == "L_" ) 
			{
				sTemp = strright( s_asItemNames[no] , size( s_asItemNames[no] ) - 2 ); 
				sName = "R_" + sTemp  ;
			}
			fX = -1 * s_avRots[no].x ; 
			fZ = -1 * s_avRots[no].z ; 
			vRot = <fX,vRot.y,fZ>;			
		}
		xName = parse( " (" , rootObj.name ) ;
		if( xName[ 1 ] == sName )
		{
			if( nil != s_avTrans[no] && s_nIKChk == 1 )
			{
				createKeys( rootObj , nil , vRot , nil , time );
				vTrans = s_avTrans[no] ;
				if( 1 == s_nSymmetry )
				{
					fX = -1 * s_avTrans[no].x ; 
					vTrans = <fX,vTrans.y,vTrans.z>;					
				}
				createKeys( rootObj , vTrans , nil , nil ,time );
			}
			else if( nil == s_avTrans[no] )
			{
				createKeys( rootObj , nil , vRot , nil , time );
			}
		}
	}
	childObj = rootObj.firstChild();
	while(childObj)
	{
		nameToId(childObj,time);
		childObj = rootObj.nextChild();
	}
}


createKeys: newItem , vTrans , vRot , vScale ,time
{
	curChannel = newItem.firstChannel();

	while( nil != curChannel )
	{
		if( vTrans != nil )
		{
			if(curChannel.name == "Position.X")
			{
				crateKey( curChannel , time ,vTrans.x);
			}
			if(curChannel.name == "Position.Y")
			{
				crateKey( curChannel , time ,vTrans.y);
			}
			if(curChannel.name == "Position.Z")
			{
				crateKey( curChannel , time ,vTrans.z);
			}
		}
		if( vRot != nil )
		{
			if(curChannel.name == "Rotation.H")
			{
				crateKey( curChannel , time ,vRot.x);
			}
			if(curChannel.name == "Rotation.P")
			{
				crateKey( curChannel , time ,vRot.y);
			}
			if(curChannel.name == "Rotation.B")
			{
				crateKey( curChannel , time ,vRot.z);
			}
		}
		if( vScale != nil )
		{
			if(curChannel.name == "Scale.X")
			{
				crateKey( curChannel , time ,vScale.x);
			}
			if(curChannel.name == "Scale.Y")
			{
				crateKey( curChannel , time ,vScale.y);
			}
			if(curChannel.name == "Scale.Z")
			{
				crateKey( curChannel , time ,vScale.z);
			}			
		}
		curChannel = newItem.nextChannel();
	}
}

crateKey: xChanel , time , value  
{
	if( 1 == s_nValueChk )
	{
		temp = xChanel.value( time );
		if( value != temp ) 
		{
			xChanel.createKey( time ,value );
		}
	}
	else {
		xChanel.createKey( time ,value );
	}
}
lb_count
{
     return(s_asItemNames.size());
}

lb_name: index
{
     return(s_asItemNames[index]);
}
